/* DUPLICATOR-LITE (PHP BUILD MODE) MYSQL SCRIPT CREATED ON : 2018-12-10 06:27:30 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10)),
  KEY `woo_idx_comment_type` (`comment_type`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) COLLATE utf8_persian_ci NOT NULL,
  `hash` varchar(50) COLLATE utf8_persian_ci NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_persian_ci NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_persian_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=555 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=349 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=45 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_wc_download_log` (
  `download_log_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `timestamp` datetime NOT NULL,
  `permission_id` bigint(20) unsigned NOT NULL,
  `user_id` bigint(20) unsigned DEFAULT NULL,
  `user_ip_address` varchar(100) COLLATE utf8mb4_unicode_520_ci DEFAULT '',
  PRIMARY KEY (`download_log_id`),
  KEY `permission_id` (`permission_id`),
  KEY `timestamp` (`timestamp`),
  CONSTRAINT `fk_wp_wc_download_log_permission_id` FOREIGN KEY (`permission_id`) REFERENCES `wp_woocommerce_downloadable_product_permissions` (`permission_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_wc_webhooks` (
  `webhook_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `status` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `name` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` bigint(20) unsigned NOT NULL,
  `delivery_url` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `secret` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `topic` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `date_created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_created_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `api_version` smallint(4) NOT NULL,
  `failure_count` smallint(10) NOT NULL DEFAULT '0',
  `pending_delivery` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`webhook_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_api_keys` (
  `key_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL,
  `description` varchar(200) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `permissions` varchar(10) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `consumer_key` char(64) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `consumer_secret` char(43) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `nonces` longtext COLLATE utf8mb4_unicode_520_ci,
  `truncated_key` char(7) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `last_access` datetime DEFAULT NULL,
  PRIMARY KEY (`key_id`),
  KEY `consumer_key` (`consumer_key`),
  KEY `consumer_secret` (`consumer_secret`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_attribute_taxonomies` (
  `attribute_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `attribute_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `attribute_label` varchar(200) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `attribute_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `attribute_orderby` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `attribute_public` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`attribute_id`),
  KEY `attribute_name` (`attribute_name`(20))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_downloadable_product_permissions` (
  `permission_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `download_id` varchar(36) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `product_id` bigint(20) unsigned NOT NULL,
  `order_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `order_key` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_email` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` bigint(20) unsigned DEFAULT NULL,
  `downloads_remaining` varchar(9) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `access_granted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access_expires` datetime DEFAULT NULL,
  `download_count` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`permission_id`),
  KEY `download_order_key_product` (`product_id`,`order_id`,`order_key`(16),`download_id`),
  KEY `download_order_product` (`download_id`,`order_id`,`product_id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_log` (
  `log_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `timestamp` datetime NOT NULL,
  `level` smallint(4) NOT NULL,
  `source` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `message` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `context` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`log_id`),
  KEY `level` (`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_order_itemmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `order_item_id` bigint(20) unsigned NOT NULL,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `order_item_id` (`order_item_id`),
  KEY `meta_key` (`meta_key`(32))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_order_items` (
  `order_item_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `order_item_name` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `order_item_type` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `order_id` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`order_item_id`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_payment_tokenmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `payment_token_id` bigint(20) unsigned NOT NULL,
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `payment_token_id` (`payment_token_id`),
  KEY `meta_key` (`meta_key`(32))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_payment_tokens` (
  `token_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `gateway_id` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `token` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `type` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `is_default` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`token_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_sessions` (
  `session_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `session_key` char(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `session_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `session_expiry` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`session_id`),
  UNIQUE KEY `session_key` (`session_key`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_shipping_zone_locations` (
  `location_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `zone_id` bigint(20) unsigned NOT NULL,
  `location_code` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `location_type` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`location_id`),
  KEY `location_id` (`location_id`),
  KEY `location_type_code` (`location_type`(10),`location_code`(20))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_shipping_zone_methods` (
  `zone_id` bigint(20) unsigned NOT NULL,
  `instance_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `method_id` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `method_order` bigint(20) unsigned NOT NULL,
  `is_enabled` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`instance_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_shipping_zones` (
  `zone_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `zone_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `zone_order` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`zone_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_tax_rate_locations` (
  `location_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `location_code` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `tax_rate_id` bigint(20) unsigned NOT NULL,
  `location_type` varchar(40) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  PRIMARY KEY (`location_id`),
  KEY `tax_rate_id` (`tax_rate_id`),
  KEY `location_type_code` (`location_type`(10),`location_code`(20))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_woocommerce_tax_rates` (
  `tax_rate_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `tax_rate_country` varchar(2) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate_state` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate` varchar(8) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `tax_rate_priority` bigint(20) unsigned NOT NULL,
  `tax_rate_compound` int(1) NOT NULL DEFAULT '0',
  `tax_rate_shipping` int(1) NOT NULL DEFAULT '1',
  `tax_rate_order` bigint(20) unsigned NOT NULL,
  `tax_rate_class` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`tax_rate_id`),
  KEY `tax_rate_country` (`tax_rate_country`),
  KEY `tax_rate_state` (`tax_rate_state`(2)),
  KEY `tax_rate_class` (`tax_rate_class`(10)),
  KEY `tax_rate_priority` (`tax_rate_priority`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;


/* INSERT TABLE DATA: wp_commentmeta */
INSERT INTO `wp_commentmeta` VALUES("1", "2", "rating", "5");
INSERT INTO `wp_commentmeta` VALUES("2", "2", "verified", "0");

/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "یک نویسنده‌ی دیدگاه در وردپرس", "wapuu@wordpress.example", "https://wordpress.org/", "", "2018-12-03 06:56:57", "2018-12-03 03:26:57", "سلام, این یک دیدگاه است.\nبرای شروع مدیریت، ویرایش و پاک کردن دیدگاه‌ها، لطفا بخش دیدگاه‌ها در پیشخوان را ببینید.\nتصاویر نویسندگان دیدگاه از <a href=\"https://gravatar.com\">Gravatar</a> گرفته می‌شود.", "0", "1", "", "", "0", "0");
INSERT INTO `wp_comments` VALUES("2", "15", "admin", "demo@iranthemes.com", "", "127.0.0.1", "2018-12-03 07:28:32", "2018-12-03 03:58:32", "محصول خوبیه", "0", "1", "Mozilla/5.0 (Windows NT 6.1; rv:63.0) Gecko/20100101 Firefox/63.0", "review", "0", "1");

/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("1", "jstore", "5758f6ab4fa6dde47394_20181210062651", "20", "2018-12-10 06:27:29", "admin", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2018-12-10 06:26:51\";s:7:\"Version\";s:6:\"1.2.52\";s:9:\"VersionWP\";s:3:\"5.0\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";i:1;s:4:\"Name\";s:6:\"jstore\";s:4:\"Hash\";s:35:\"5758f6ab4fa6dde47394_20181210062651\";s:8:\"NameHash\";s:42:\"jstore_5758f6ab4fa6dde47394_20181210062651\";s:4:\"Type\";i:0;s:5:\"Notes\";s:57:\"jstore wordpress theme install packages by iranthemes.com\";s:9:\"StorePath\";s:47:\"G:/Program Files/wamp/www/demo/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://localhost/demo/wp-snapshots/\";s:8:\"ScanFile\";s:52:\"jstore_5758f6ab4fa6dde47394_20181210062651_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";s:5:\"admin\";s:7:\"Archive\";O:11:\"DUP_Archive\":19:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:54:\"jstore_5758f6ab4fa6dde47394_20181210062651_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:30:\"G:/Program Files/wamp/www/demo\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":4:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":5:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":2:{s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2018-12-10 06:26:51\";s:7:\"Version\";s:6:\"1.2.52\";s:9:\"VersionWP\";s:3:\"5.0\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:6:\"jstore\";s:4:\"Hash\";s:35:\"5758f6ab4fa6dde47394_20181210062651\";s:8:\"NameHash\";s:42:\"jstore_5758f6ab4fa6dde47394_20181210062651\";s:4:\"Type\";i:0;s:5:\"Notes\";s:57:\"jstore wordpress theme install packages by iranthemes.com\";s:9:\"StorePath\";s:47:\"G:/Program Files/wamp/www/demo/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://localhost/demo/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";r:22;s:9:\"Installer\";O:13:\"DUP_Installer\":9:{s:4:\"File\";s:56:\"jstore_5758f6ab4fa6dde47394_20181210062651_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:10:\"\0*\0Package\";r:58;}s:8:\"Database\";O:12:\"DUP_Database\":13:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:55:\"jstore_5758f6ab4fa6dde47394_20181210062651_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:6:{i:0;s:39:\"G:/Program Files/wamp/www/demo/wp-admin\";i:1;s:49:\"G:/Program Files/wamp/www/demo/wp-content/uploads\";i:2;s:51:\"G:/Program Files/wamp/www/demo/wp-content/languages\";i:3;s:49:\"G:/Program Files/wamp/www/demo/wp-content/plugins\";i:4;s:48:\"G:/Program Files/wamp/www/demo/wp-content/themes\";i:5;s:42:\"G:/Program Files/wamp/www/demo/wp-includes\";}}s:9:\"Installer\";r:80;s:8:\"Database\";r:90;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://localhost/demo", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://localhost/demo", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "ایران تمز - iranthemes.com", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "فروشگاه کوچک من", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "demo@iranthemes.com", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "6", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "4", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "open", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "4", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "0", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%year%/%monthnum%/%day%/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "rewrite_rules", "a:157:{s:24:\"^wc-auth/v([1]{1})/(.*)?\";s:63:\"index.php?wc-auth-version=$matches[1]&wc-auth-route=$matches[2]\";s:22:\"^wc-api/v([1-3]{1})/?$\";s:51:\"index.php?wc-api-version=$matches[1]&wc-api-route=/\";s:24:\"^wc-api/v([1-3]{1})(.*)?\";s:61:\"index.php?wc-api-version=$matches[1]&wc-api-route=$matches[2]\";s:7:\"shop/?$\";s:27:\"index.php?post_type=product\";s:37:\"shop/feed/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=product&feed=$matches[1]\";s:32:\"shop/(feed|rdf|rss|rss2|atom)/?$\";s:44:\"index.php?post_type=product&feed=$matches[1]\";s:24:\"shop/page/([0-9]{1,})/?$\";s:45:\"index.php?post_type=product&paged=$matches[1]\";s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:32:\"category/(.+?)/wc-api(/(.*))?/?$\";s:54:\"index.php?category_name=$matches[1]&wc-api=$matches[3]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:29:\"tag/([^/]+)/wc-api(/(.*))?/?$\";s:44:\"index.php?tag=$matches[1]&wc-api=$matches[3]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:55:\"product-category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_cat=$matches[1]&feed=$matches[2]\";s:50:\"product-category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_cat=$matches[1]&feed=$matches[2]\";s:31:\"product-category/(.+?)/embed/?$\";s:44:\"index.php?product_cat=$matches[1]&embed=true\";s:43:\"product-category/(.+?)/page/?([0-9]{1,})/?$\";s:51:\"index.php?product_cat=$matches[1]&paged=$matches[2]\";s:25:\"product-category/(.+?)/?$\";s:33:\"index.php?product_cat=$matches[1]\";s:52:\"product-tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_tag=$matches[1]&feed=$matches[2]\";s:47:\"product-tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?product_tag=$matches[1]&feed=$matches[2]\";s:28:\"product-tag/([^/]+)/embed/?$\";s:44:\"index.php?product_tag=$matches[1]&embed=true\";s:40:\"product-tag/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?product_tag=$matches[1]&paged=$matches[2]\";s:22:\"product-tag/([^/]+)/?$\";s:33:\"index.php?product_tag=$matches[1]\";s:35:\"product/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:45:\"product/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:65:\"product/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"product/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:60:\"product/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:41:\"product/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:24:\"product/([^/]+)/embed/?$\";s:40:\"index.php?product=$matches[1]&embed=true\";s:28:\"product/([^/]+)/trackback/?$\";s:34:\"index.php?product=$matches[1]&tb=1\";s:48:\"product/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?product=$matches[1]&feed=$matches[2]\";s:43:\"product/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:46:\"index.php?product=$matches[1]&feed=$matches[2]\";s:36:\"product/([^/]+)/page/?([0-9]{1,})/?$\";s:47:\"index.php?product=$matches[1]&paged=$matches[2]\";s:43:\"product/([^/]+)/comment-page-([0-9]{1,})/?$\";s:47:\"index.php?product=$matches[1]&cpage=$matches[2]\";s:33:\"product/([^/]+)/wc-api(/(.*))?/?$\";s:48:\"index.php?product=$matches[1]&wc-api=$matches[3]\";s:39:\"product/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:50:\"product/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:32:\"product/([^/]+)(?:/([0-9]+))?/?$\";s:46:\"index.php?product=$matches[1]&page=$matches[2]\";s:24:\"product/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:34:\"product/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:54:\"product/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"product/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:49:\"product/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:30:\"product/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:39:\"index.php?&page_id=35&cpage=$matches[1]\";s:17:\"wc-api(/(.*))?/?$\";s:29:\"index.php?&wc-api=$matches[2]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:26:\"comments/wc-api(/(.*))?/?$\";s:29:\"index.php?&wc-api=$matches[2]\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:29:\"search/(.+)/wc-api(/(.*))?/?$\";s:42:\"index.php?s=$matches[1]&wc-api=$matches[3]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:32:\"author/([^/]+)/wc-api(/(.*))?/?$\";s:52:\"index.php?author_name=$matches[1]&wc-api=$matches[3]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:54:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/wc-api(/(.*))?/?$\";s:82:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&wc-api=$matches[5]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:41:\"([0-9]{4})/([0-9]{1,2})/wc-api(/(.*))?/?$\";s:66:\"index.php?year=$matches[1]&monthnum=$matches[2]&wc-api=$matches[4]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:28:\"([0-9]{4})/wc-api(/(.*))?/?$\";s:45:\"index.php?year=$matches[1]&wc-api=$matches[3]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:64:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:53:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/embed/?$\";s:91:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/comment-page-([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&cpage=$matches[5]\";s:62:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/wc-api(/(.*))?/?$\";s:99:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&wc-api=$matches[6]\";s:62:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:73:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:61:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(?:/([0-9]+))?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:53:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&cpage=$matches[4]\";s:51:\"([0-9]{4})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&cpage=$matches[3]\";s:38:\"([0-9]{4})/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&cpage=$matches[2]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:25:\"(.?.+?)/wc-api(/(.*))?/?$\";s:49:\"index.php?pagename=$matches[1]&wc-api=$matches[3]\";s:28:\"(.?.+?)/order-pay(/(.*))?/?$\";s:52:\"index.php?pagename=$matches[1]&order-pay=$matches[3]\";s:33:\"(.?.+?)/order-received(/(.*))?/?$\";s:57:\"index.php?pagename=$matches[1]&order-received=$matches[3]\";s:25:\"(.?.+?)/orders(/(.*))?/?$\";s:49:\"index.php?pagename=$matches[1]&orders=$matches[3]\";s:29:\"(.?.+?)/view-order(/(.*))?/?$\";s:53:\"index.php?pagename=$matches[1]&view-order=$matches[3]\";s:28:\"(.?.+?)/downloads(/(.*))?/?$\";s:52:\"index.php?pagename=$matches[1]&downloads=$matches[3]\";s:31:\"(.?.+?)/edit-account(/(.*))?/?$\";s:55:\"index.php?pagename=$matches[1]&edit-account=$matches[3]\";s:31:\"(.?.+?)/edit-address(/(.*))?/?$\";s:55:\"index.php?pagename=$matches[1]&edit-address=$matches[3]\";s:34:\"(.?.+?)/payment-methods(/(.*))?/?$\";s:58:\"index.php?pagename=$matches[1]&payment-methods=$matches[3]\";s:32:\"(.?.+?)/lost-password(/(.*))?/?$\";s:56:\"index.php?pagename=$matches[1]&lost-password=$matches[3]\";s:34:\"(.?.+?)/customer-logout(/(.*))?/?$\";s:58:\"index.php?pagename=$matches[1]&customer-logout=$matches[3]\";s:37:\"(.?.+?)/add-payment-method(/(.*))?/?$\";s:61:\"index.php?pagename=$matches[1]&add-payment-method=$matches[3]\";s:40:\"(.?.+?)/delete-payment-method(/(.*))?/?$\";s:64:\"index.php?pagename=$matches[1]&delete-payment-method=$matches[3]\";s:45:\"(.?.+?)/set-default-payment-method(/(.*))?/?$\";s:69:\"index.php?pagename=$matches[1]&set-default-payment-method=$matches[3]\";s:31:\".?.+?/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:42:\".?.+?/attachment/([^/]+)/wc-api(/(.*))?/?$\";s:51:\"index.php?attachment=$matches[1]&wc-api=$matches[3]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:3:{i:0;s:33:\"classic-editor/classic-editor.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:27:\"woocommerce/woocommerce.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("37", "gmt_offset", "+3.5", "yes");
INSERT INTO `wp_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("39", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("40", "template", "jstore", "yes");
INSERT INTO `wp_options` VALUES("41", "stylesheet", "jstore", "yes");
INSERT INTO `wp_options` VALUES("42", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("43", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("44", "comment_registration", "0", "yes");
INSERT INTO `wp_options` VALUES("45", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("46", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("47", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("48", "db_version", "43764", "yes");
INSERT INTO `wp_options` VALUES("49", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("50", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("51", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("52", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("53", "show_on_front", "page", "yes");
INSERT INTO `wp_options` VALUES("54", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("55", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("56", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("57", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("58", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("61", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("64", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "image_default_link_type", "none", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("69", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("71", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("73", "page_comments", "0", "yes");
INSERT INTO `wp_options` VALUES("74", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("75", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("76", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("77", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("78", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_text", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("81", "uninstall_plugins", "a:1:{s:33:\"classic-editor/classic-editor.php\";a:2:{i:0;s:14:\"Classic_Editor\";i:1;s:9:\"uninstall\";}}", "no");
INSERT INTO `wp_options` VALUES("82", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("83", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("84", "page_on_front", "35", "yes");
INSERT INTO `wp_options` VALUES("85", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("86", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `wp_options` VALUES("88", "site_icon", "0", "yes");
INSERT INTO `wp_options` VALUES("89", "medium_large_size_w", "768", "yes");
INSERT INTO `wp_options` VALUES("90", "medium_large_size_h", "0", "yes");
INSERT INTO `wp_options` VALUES("91", "wp_page_for_privacy_policy", "3", "yes");
INSERT INTO `wp_options` VALUES("92", "show_comments_cookies_opt_in", "0", "yes");
INSERT INTO `wp_options` VALUES("93", "initial_db_version", "38590", "yes");
INSERT INTO `wp_options` VALUES("94", "wp_user_roles", "a:7:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:114:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:18:\"manage_woocommerce\";b:1;s:24:\"view_woocommerce_reports\";b:1;s:12:\"edit_product\";b:1;s:12:\"read_product\";b:1;s:14:\"delete_product\";b:1;s:13:\"edit_products\";b:1;s:20:\"edit_others_products\";b:1;s:16:\"publish_products\";b:1;s:21:\"read_private_products\";b:1;s:15:\"delete_products\";b:1;s:23:\"delete_private_products\";b:1;s:25:\"delete_published_products\";b:1;s:22:\"delete_others_products\";b:1;s:21:\"edit_private_products\";b:1;s:23:\"edit_published_products\";b:1;s:20:\"manage_product_terms\";b:1;s:18:\"edit_product_terms\";b:1;s:20:\"delete_product_terms\";b:1;s:20:\"assign_product_terms\";b:1;s:15:\"edit_shop_order\";b:1;s:15:\"read_shop_order\";b:1;s:17:\"delete_shop_order\";b:1;s:16:\"edit_shop_orders\";b:1;s:23:\"edit_others_shop_orders\";b:1;s:19:\"publish_shop_orders\";b:1;s:24:\"read_private_shop_orders\";b:1;s:18:\"delete_shop_orders\";b:1;s:26:\"delete_private_shop_orders\";b:1;s:28:\"delete_published_shop_orders\";b:1;s:25:\"delete_others_shop_orders\";b:1;s:24:\"edit_private_shop_orders\";b:1;s:26:\"edit_published_shop_orders\";b:1;s:23:\"manage_shop_order_terms\";b:1;s:21:\"edit_shop_order_terms\";b:1;s:23:\"delete_shop_order_terms\";b:1;s:23:\"assign_shop_order_terms\";b:1;s:16:\"edit_shop_coupon\";b:1;s:16:\"read_shop_coupon\";b:1;s:18:\"delete_shop_coupon\";b:1;s:17:\"edit_shop_coupons\";b:1;s:24:\"edit_others_shop_coupons\";b:1;s:20:\"publish_shop_coupons\";b:1;s:25:\"read_private_shop_coupons\";b:1;s:19:\"delete_shop_coupons\";b:1;s:27:\"delete_private_shop_coupons\";b:1;s:29:\"delete_published_shop_coupons\";b:1;s:26:\"delete_others_shop_coupons\";b:1;s:25:\"edit_private_shop_coupons\";b:1;s:27:\"edit_published_shop_coupons\";b:1;s:24:\"manage_shop_coupon_terms\";b:1;s:22:\"edit_shop_coupon_terms\";b:1;s:24:\"delete_shop_coupon_terms\";b:1;s:24:\"assign_shop_coupon_terms\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}s:8:\"customer\";a:2:{s:4:\"name\";s:8:\"Customer\";s:12:\"capabilities\";a:1:{s:4:\"read\";b:1;}}s:12:\"shop_manager\";a:2:{s:4:\"name\";s:12:\"Shop manager\";s:12:\"capabilities\";a:93:{s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:4:\"read\";b:1;s:18:\"read_private_pages\";b:1;s:18:\"read_private_posts\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_posts\";b:1;s:10:\"edit_pages\";b:1;s:20:\"edit_published_posts\";b:1;s:20:\"edit_published_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"edit_private_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:17:\"edit_others_pages\";b:1;s:13:\"publish_posts\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_posts\";b:1;s:12:\"delete_pages\";b:1;s:20:\"delete_private_pages\";b:1;s:20:\"delete_private_posts\";b:1;s:22:\"delete_published_pages\";b:1;s:22:\"delete_published_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:19:\"delete_others_pages\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:17:\"moderate_comments\";b:1;s:12:\"upload_files\";b:1;s:6:\"export\";b:1;s:6:\"import\";b:1;s:10:\"list_users\";b:1;s:18:\"edit_theme_options\";b:1;s:18:\"manage_woocommerce\";b:1;s:24:\"view_woocommerce_reports\";b:1;s:12:\"edit_product\";b:1;s:12:\"read_product\";b:1;s:14:\"delete_product\";b:1;s:13:\"edit_products\";b:1;s:20:\"edit_others_products\";b:1;s:16:\"publish_products\";b:1;s:21:\"read_private_products\";b:1;s:15:\"delete_products\";b:1;s:23:\"delete_private_products\";b:1;s:25:\"delete_published_products\";b:1;s:22:\"delete_others_products\";b:1;s:21:\"edit_private_products\";b:1;s:23:\"edit_published_products\";b:1;s:20:\"manage_product_terms\";b:1;s:18:\"edit_product_terms\";b:1;s:20:\"delete_product_terms\";b:1;s:20:\"assign_product_terms\";b:1;s:15:\"edit_shop_order\";b:1;s:15:\"read_shop_order\";b:1;s:17:\"delete_shop_order\";b:1;s:16:\"edit_shop_orders\";b:1;s:23:\"edit_others_shop_orders\";b:1;s:19:\"publish_shop_orders\";b:1;s:24:\"read_private_shop_orders\";b:1;s:18:\"delete_shop_orders\";b:1;s:26:\"delete_private_shop_orders\";b:1;s:28:\"delete_published_shop_orders\";b:1;s:25:\"delete_others_shop_orders\";b:1;s:24:\"edit_private_shop_orders\";b:1;s:26:\"edit_published_shop_orders\";b:1;s:23:\"manage_shop_order_terms\";b:1;s:21:\"edit_shop_order_terms\";b:1;s:23:\"delete_shop_order_terms\";b:1;s:23:\"assign_shop_order_terms\";b:1;s:16:\"edit_shop_coupon\";b:1;s:16:\"read_shop_coupon\";b:1;s:18:\"delete_shop_coupon\";b:1;s:17:\"edit_shop_coupons\";b:1;s:24:\"edit_others_shop_coupons\";b:1;s:20:\"publish_shop_coupons\";b:1;s:25:\"read_private_shop_coupons\";b:1;s:19:\"delete_shop_coupons\";b:1;s:27:\"delete_private_shop_coupons\";b:1;s:29:\"delete_published_shop_coupons\";b:1;s:26:\"delete_others_shop_coupons\";b:1;s:25:\"edit_private_shop_coupons\";b:1;s:27:\"edit_published_shop_coupons\";b:1;s:24:\"manage_shop_coupon_terms\";b:1;s:22:\"edit_shop_coupon_terms\";b:1;s:24:\"delete_shop_coupon_terms\";b:1;s:24:\"assign_shop_coupon_terms\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("95", "fresh_site", "0", "yes");
INSERT INTO `wp_options` VALUES("96", "WPLANG", "fa_IR", "yes");
INSERT INTO `wp_options` VALUES("97", "widget_search", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("98", "widget_recent-posts", "a:3:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;i:4;a:3:{s:5:\"title\";s:27:\"جدیدترین مطالب\";s:6:\"number\";i:3;s:9:\"show_date\";b:0;}}", "yes");
INSERT INTO `wp_options` VALUES("99", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:17:\"دیدکاه ها\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("100", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("101", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:23:\"اطلاعات ورود\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("102", "sidebars_widgets", "a:9:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:2:{i:0;s:14:\"recent-posts-2\";i:1;s:12:\"categories-2\";}s:12:\"sidebar-shop\";a:4:{i:0;s:32:\"woocommerce_product_categories-2\";i:1;s:27:\"woocommerce_rating_filter-2\";i:2;s:26:\"woocommerce_price_filter-2\";i:3;s:33:\"woocommerce_layered_nav_filters-2\";}s:14:\"jstore-footer1\";a:1:{i:0;s:31:\"woocommerce_product_tag_cloud-3\";}s:14:\"jstore-footer2\";a:1:{i:0;s:7:\"pages-3\";}s:14:\"jstore-footer3\";a:1:{i:0;s:14:\"recent-posts-4\";}s:14:\"jstore-footer4\";a:1:{i:0;s:17:\"recent-comments-2\";}s:14:\"jstore-footer5\";a:1:{i:0;s:6:\"meta-2\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("103", "widget_pages", "a:2:{s:12:\"_multiwidget\";i:1;i:3;a:3:{s:5:\"title\";s:21:\"دسترسی سریع\";s:6:\"sortby\";s:10:\"post_title\";s:7:\"exclude\";s:0:\"\";}}", "yes");
INSERT INTO `wp_options` VALUES("104", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("105", "widget_media_audio", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("106", "widget_media_image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("107", "widget_media_gallery", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("108", "widget_media_video", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("109", "nonce_key", "E)]nbGr]![wWCr]FN%]TmRFL*2Yd~Ey!fF)soocR?,M.M#SoaO<A@`9,ZpSQ}OXW", "no");
INSERT INTO `wp_options` VALUES("110", "nonce_salt", ",@KKwb>U(e<dhj9V5&XTj[wifMRrRpn>;=4.t${0VJXSTvvmM2q~$ZUD(u|>sj@@", "no");
INSERT INTO `wp_options` VALUES("111", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("112", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("113", "widget_custom_html", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("114", "cron", "a:13:{i:1544423294;a:1:{s:26:\"action_scheduler_run_queue\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:12:\"every_minute\";s:4:\"args\";a:0:{}s:8:\"interval\";i:60;}}}i:1544423767;a:1:{s:24:\"woocommerce_cleanup_logs\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1544425773;a:1:{s:32:\"woocommerce_cancel_unpaid_orders\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:0:{}}}}i:1544426821;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1544434567;a:1:{s:28:\"woocommerce_cleanup_sessions\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1544455621;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1544475600;a:1:{s:27:\"woocommerce_scheduled_sales\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1544499046;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1544499367;a:1:{s:33:\"woocommerce_cleanup_personal_data\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1544499377;a:1:{s:30:\"woocommerce_tracker_send_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1544500454;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1546300800;a:1:{s:25:\"woocommerce_geoip_updater\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2635200;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("115", "theme_mods_twentyseventeen", "a:2:{s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1543808069;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("125", "auth_key", "p&_-f$aSl=4jO0_s,jPiJNw~jRiW>tbuP.gRp%235fl#rw6T<oU(R,QO_~<|q.*C", "no");
INSERT INTO `wp_options` VALUES("126", "auth_salt", "6U}+LU#[&C_$N,%CjIbi)25d:P*QGs4/5t@kjq<:,5VyKpw4c%sQ>-#2$g<|hLJr", "no");
INSERT INTO `wp_options` VALUES("127", "logged_in_key", "E</EUvZ/O@X+3U<u]qD3>)ts>Rt_*_T0-!QefZ3Z6jaQ<oI,)pClrH;ARVt2JX$e", "no");
INSERT INTO `wp_options` VALUES("128", "logged_in_salt", "zRQgy8d7]+H$!<|DC:$[vqlV:/CXVK`~:>},v0r>E,GA->{Z$c^|Vdyr[`Wjt7nx", "no");
INSERT INTO `wp_options` VALUES("149", "current_theme", "Jstore", "yes");
INSERT INTO `wp_options` VALUES("150", "theme_mods_jstore", "a:24:{i:0;b:0;s:18:\"nav_menu_locations\";a:0:{}s:18:\"custom_css_post_id\";i:-1;s:11:\"custom_logo\";s:0:\"\";s:21:\"jstore_cust_care_text\";s:58:\"فروشگاه اینترنتی جی استور فارسی\";s:25:\"jstore_home_banner_on_off\";s:2:\"on\";s:15:\"jstore_bnr_img1\";s:65:\"http://localhost/demo/wp-content/uploads/2018/12/banner02-1-2.jpg\";s:15:\"jstore_bnr_img2\";s:65:\"http://localhost/demo/wp-content/uploads/2018/12/banner02-1-2.jpg\";s:26:\"jstore_small_banner_on_off\";s:2:\"on\";s:21:\"jstore-small-banner-1\";s:65:\"http://localhost/demo/wp-content/uploads/2018/12/sbanner3-1-2.jpg\";s:21:\"jstore-small-banner-2\";s:65:\"http://localhost/demo/wp-content/uploads/2018/12/sbanner1-1-2.jpg\";s:21:\"jstore-small-banner-3\";s:65:\"http://localhost/demo/wp-content/uploads/2018/12/sbanner2-1-2.jpg\";s:22:\"jstore_our_brand_logo1\";s:57:\"http://localhost/demo/wp-content/uploads/2018/12/01-2.jpg\";s:22:\"jstore_our_brand_logo2\";s:57:\"http://localhost/demo/wp-content/uploads/2018/12/02-2.jpg\";s:22:\"jstore_our_brand_logo3\";s:57:\"http://localhost/demo/wp-content/uploads/2018/12/04-2.jpg\";s:22:\"jstore_our_brand_logo4\";s:57:\"http://localhost/demo/wp-content/uploads/2018/12/06-2.jpg\";s:22:\"jstore_our_brand_logo5\";s:57:\"http://localhost/demo/wp-content/uploads/2018/12/03-2.jpg\";s:22:\"jstore_our_brand_logo6\";s:57:\"http://localhost/demo/wp-content/uploads/2018/12/07-2.jpg\";s:21:\"jstore_copyright_text\";s:42:\"طراحی و اجرا : ایران تمز\";s:12:\"header_image\";s:13:\"remove-header\";s:19:\"jstore_cust_care_no\";s:11:\"09158856205\";s:19:\"jstore_new_arvl_itm\";s:31:\"جدیدترین محصولات\";s:18:\"jstore_top_rtd_itm\";s:53:\"محصولات دارای بیشترین امتیاز\";s:21:\"jstore_top_seling_itm\";s:36:\"پرفروش ترین محصولات\";}", "yes");
INSERT INTO `wp_options` VALUES("151", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("154", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("158", "woocommerce_store_address", "خراسان شمالی", "yes");
INSERT INTO `wp_options` VALUES("159", "woocommerce_store_address_2", "", "yes");
INSERT INTO `wp_options` VALUES("160", "woocommerce_store_city", "شیروان", "yes");
INSERT INTO `wp_options` VALUES("161", "woocommerce_default_country", "IR:NKH", "yes");
INSERT INTO `wp_options` VALUES("162", "woocommerce_store_postcode", "9461946485", "yes");
INSERT INTO `wp_options` VALUES("163", "woocommerce_allowed_countries", "all", "yes");
INSERT INTO `wp_options` VALUES("164", "woocommerce_all_except_countries", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("165", "woocommerce_specific_allowed_countries", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("166", "woocommerce_ship_to_countries", "", "yes");
INSERT INTO `wp_options` VALUES("167", "woocommerce_specific_ship_to_countries", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("168", "woocommerce_default_customer_address", "geolocation", "yes");
INSERT INTO `wp_options` VALUES("169", "woocommerce_calc_taxes", "no", "yes");
INSERT INTO `wp_options` VALUES("170", "woocommerce_enable_coupons", "yes", "yes");
INSERT INTO `wp_options` VALUES("171", "woocommerce_calc_discounts_sequentially", "no", "no");
INSERT INTO `wp_options` VALUES("172", "woocommerce_currency", "IRT", "yes");
INSERT INTO `wp_options` VALUES("173", "woocommerce_currency_pos", "right", "yes");
INSERT INTO `wp_options` VALUES("174", "woocommerce_price_thousand_sep", ",", "yes");
INSERT INTO `wp_options` VALUES("175", "woocommerce_price_decimal_sep", ".", "yes");
INSERT INTO `wp_options` VALUES("176", "woocommerce_price_num_decimals", "0", "yes");
INSERT INTO `wp_options` VALUES("177", "woocommerce_shop_page_id", "5", "yes");
INSERT INTO `wp_options` VALUES("178", "woocommerce_cart_redirect_after_add", "no", "yes");
INSERT INTO `wp_options` VALUES("179", "woocommerce_enable_ajax_add_to_cart", "yes", "yes");
INSERT INTO `wp_options` VALUES("180", "woocommerce_placeholder_image", "", "yes");
INSERT INTO `wp_options` VALUES("181", "woocommerce_weight_unit", "kg", "yes");
INSERT INTO `wp_options` VALUES("182", "woocommerce_dimension_unit", "cm", "yes");
INSERT INTO `wp_options` VALUES("183", "woocommerce_enable_reviews", "yes", "yes");
INSERT INTO `wp_options` VALUES("184", "woocommerce_review_rating_verification_label", "yes", "no");
INSERT INTO `wp_options` VALUES("185", "woocommerce_review_rating_verification_required", "no", "no");
INSERT INTO `wp_options` VALUES("186", "woocommerce_enable_review_rating", "yes", "yes");
INSERT INTO `wp_options` VALUES("187", "woocommerce_review_rating_required", "yes", "no");
INSERT INTO `wp_options` VALUES("188", "woocommerce_manage_stock", "yes", "yes");
INSERT INTO `wp_options` VALUES("189", "woocommerce_hold_stock_minutes", "60", "no");
INSERT INTO `wp_options` VALUES("190", "woocommerce_notify_low_stock", "yes", "no");
INSERT INTO `wp_options` VALUES("191", "woocommerce_notify_no_stock", "yes", "no");
INSERT INTO `wp_options` VALUES("192", "woocommerce_stock_email_recipient", "demo@iranthemes.com", "no");
INSERT INTO `wp_options` VALUES("193", "woocommerce_notify_low_stock_amount", "2", "no");
INSERT INTO `wp_options` VALUES("194", "woocommerce_notify_no_stock_amount", "0", "yes");
INSERT INTO `wp_options` VALUES("195", "woocommerce_hide_out_of_stock_items", "no", "yes");
INSERT INTO `wp_options` VALUES("196", "woocommerce_stock_format", "", "yes");
INSERT INTO `wp_options` VALUES("197", "woocommerce_file_download_method", "force", "no");
INSERT INTO `wp_options` VALUES("198", "woocommerce_downloads_require_login", "no", "no");
INSERT INTO `wp_options` VALUES("199", "woocommerce_downloads_grant_access_after_payment", "yes", "no");
INSERT INTO `wp_options` VALUES("200", "woocommerce_prices_include_tax", "no", "yes");
INSERT INTO `wp_options` VALUES("201", "woocommerce_tax_based_on", "shipping", "yes");
INSERT INTO `wp_options` VALUES("203", "woocommerce_shipping_tax_class", "inherit", "yes");
INSERT INTO `wp_options` VALUES("204", "woocommerce_tax_round_at_subtotal", "no", "yes");
INSERT INTO `wp_options` VALUES("205", "woocommerce_tax_classes", "کاهش رتبه \r\n رتبه صفر", "yes");
INSERT INTO `wp_options` VALUES("206", "woocommerce_tax_display_shop", "excl", "yes");
INSERT INTO `wp_options` VALUES("207", "woocommerce_tax_display_cart", "excl", "yes");
INSERT INTO `wp_options` VALUES("208", "woocommerce_price_display_suffix", "", "yes");
INSERT INTO `wp_options` VALUES("209", "woocommerce_tax_total_display", "itemized", "no");
INSERT INTO `wp_options` VALUES("210", "woocommerce_enable_shipping_calc", "yes", "no");
INSERT INTO `wp_options` VALUES("211", "woocommerce_shipping_cost_requires_address", "no", "yes");
INSERT INTO `wp_options` VALUES("212", "woocommerce_ship_to_destination", "billing", "no");
INSERT INTO `wp_options` VALUES("213", "woocommerce_shipping_debug_mode", "no", "yes");
INSERT INTO `wp_options` VALUES("214", "woocommerce_enable_guest_checkout", "yes", "no");
INSERT INTO `wp_options` VALUES("215", "woocommerce_enable_checkout_login_reminder", "no", "no");
INSERT INTO `wp_options` VALUES("216", "woocommerce_enable_signup_and_login_from_checkout", "no", "no");
INSERT INTO `wp_options` VALUES("217", "woocommerce_enable_myaccount_registration", "no", "no");
INSERT INTO `wp_options` VALUES("218", "woocommerce_registration_generate_username", "yes", "no");
INSERT INTO `wp_options` VALUES("219", "woocommerce_registration_generate_password", "yes", "no");
INSERT INTO `wp_options` VALUES("220", "woocommerce_erasure_request_removes_order_data", "no", "no");
INSERT INTO `wp_options` VALUES("221", "woocommerce_erasure_request_removes_download_data", "no", "no");
INSERT INTO `wp_options` VALUES("222", "woocommerce_registration_privacy_policy_text", "اطلاعات شخصی شما برای پردازش سفارش شما استفاده می‌شود، و پشتیبانی از تجربه شما در این وبسایت، و برای اهداف دیگری که در [privacy_policy] توضیح داده شده است.", "yes");
INSERT INTO `wp_options` VALUES("223", "woocommerce_checkout_privacy_policy_text", "Your personal data will be used to process your order, support your experience throughout this website, and for other purposes described in our [privacy_policy].", "yes");
INSERT INTO `wp_options` VALUES("224", "woocommerce_delete_inactive_accounts", "a:2:{s:6:\"number\";s:0:\"\";s:4:\"unit\";s:6:\"months\";}", "no");
INSERT INTO `wp_options` VALUES("225", "woocommerce_trash_pending_orders", "", "no");
INSERT INTO `wp_options` VALUES("226", "woocommerce_trash_failed_orders", "", "no");
INSERT INTO `wp_options` VALUES("227", "woocommerce_trash_cancelled_orders", "", "no");
INSERT INTO `wp_options` VALUES("228", "woocommerce_anonymize_completed_orders", "a:2:{s:6:\"number\";s:0:\"\";s:4:\"unit\";s:6:\"months\";}", "no");
INSERT INTO `wp_options` VALUES("229", "woocommerce_email_from_name", "ایران تمز &#8211; iranthemes.com", "no");
INSERT INTO `wp_options` VALUES("230", "woocommerce_email_from_address", "demo@iranthemes.com", "no");
INSERT INTO `wp_options` VALUES("231", "woocommerce_email_header_image", "", "no");
INSERT INTO `wp_options` VALUES("232", "woocommerce_email_footer_text", "{site_title}<br/>Powered by <a href=\"https://woocommerce.com/\">WooCommerce</a>", "no");
INSERT INTO `wp_options` VALUES("233", "woocommerce_email_base_color", "#96588a", "no");
INSERT INTO `wp_options` VALUES("234", "woocommerce_email_background_color", "#f7f7f7", "no");
INSERT INTO `wp_options` VALUES("235", "woocommerce_email_body_background_color", "#ffffff", "no");
INSERT INTO `wp_options` VALUES("236", "woocommerce_email_text_color", "#3c3c3c", "no");
INSERT INTO `wp_options` VALUES("237", "woocommerce_cart_page_id", "6", "yes");
INSERT INTO `wp_options` VALUES("238", "woocommerce_checkout_page_id", "7", "yes");
INSERT INTO `wp_options` VALUES("239", "woocommerce_myaccount_page_id", "8", "yes");
INSERT INTO `wp_options` VALUES("240", "woocommerce_terms_page_id", "", "no");
INSERT INTO `wp_options` VALUES("241", "woocommerce_force_ssl_checkout", "no", "yes");
INSERT INTO `wp_options` VALUES("242", "woocommerce_unforce_ssl_checkout", "no", "yes");
INSERT INTO `wp_options` VALUES("243", "woocommerce_checkout_pay_endpoint", "order-pay", "yes");
INSERT INTO `wp_options` VALUES("244", "woocommerce_checkout_order_received_endpoint", "order-received", "yes");
INSERT INTO `wp_options` VALUES("245", "woocommerce_myaccount_add_payment_method_endpoint", "add-payment-method", "yes");
INSERT INTO `wp_options` VALUES("246", "woocommerce_myaccount_delete_payment_method_endpoint", "delete-payment-method", "yes");
INSERT INTO `wp_options` VALUES("247", "woocommerce_myaccount_set_default_payment_method_endpoint", "set-default-payment-method", "yes");
INSERT INTO `wp_options` VALUES("248", "woocommerce_myaccount_orders_endpoint", "orders", "yes");
INSERT INTO `wp_options` VALUES("249", "woocommerce_myaccount_view_order_endpoint", "view-order", "yes");
INSERT INTO `wp_options` VALUES("250", "woocommerce_myaccount_downloads_endpoint", "downloads", "yes");
INSERT INTO `wp_options` VALUES("251", "woocommerce_myaccount_edit_account_endpoint", "edit-account", "yes");
INSERT INTO `wp_options` VALUES("252", "woocommerce_myaccount_edit_address_endpoint", "edit-address", "yes");
INSERT INTO `wp_options` VALUES("253", "woocommerce_myaccount_payment_methods_endpoint", "payment-methods", "yes");
INSERT INTO `wp_options` VALUES("254", "woocommerce_myaccount_lost_password_endpoint", "lost-password", "yes");
INSERT INTO `wp_options` VALUES("255", "woocommerce_logout_endpoint", "customer-logout", "yes");
INSERT INTO `wp_options` VALUES("256", "woocommerce_api_enabled", "no", "yes");
INSERT INTO `wp_options` VALUES("257", "woocommerce_single_image_width", "600", "yes");
INSERT INTO `wp_options` VALUES("258", "woocommerce_thumbnail_image_width", "300", "yes");
INSERT INTO `wp_options` VALUES("259", "woocommerce_checkout_highlight_required_fields", "yes", "yes");
INSERT INTO `wp_options` VALUES("260", "woocommerce_demo_store", "no", "no");
INSERT INTO `wp_options` VALUES("261", "woocommerce_permalinks", "a:5:{s:12:\"product_base\";s:7:\"product\";s:13:\"category_base\";s:16:\"product-category\";s:8:\"tag_base\";s:11:\"product-tag\";s:14:\"attribute_base\";s:0:\"\";s:22:\"use_verbose_page_rules\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("262", "current_theme_supports_woocommerce", "yes", "yes");
INSERT INTO `wp_options` VALUES("263", "woocommerce_queue_flush_rewrite_rules", "no", "yes");
INSERT INTO `wp_options` VALUES("264", "_transient_wc_attribute_taxonomies", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("266", "default_product_cat", "15", "yes");
INSERT INTO `wp_options` VALUES("269", "woocommerce_version", "3.5.2", "yes");
INSERT INTO `wp_options` VALUES("270", "woocommerce_db_version", "3.5.2", "yes");
INSERT INTO `wp_options` VALUES("271", "woocommerce_admin_notices", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("272", "_transient_woocommerce_webhook_ids", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("273", "widget_woocommerce_widget_cart", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("274", "widget_woocommerce_layered_nav_filters", "a:2:{i:2;a:1:{s:5:\"title\";s:25:\"فیلترهای فعال\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("275", "widget_woocommerce_layered_nav", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("276", "widget_woocommerce_price_filter", "a:2:{i:2;a:1:{s:5:\"title\";s:34:\"فیلتر براساس قیمت :\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("277", "widget_woocommerce_product_categories", "a:2:{i:2;a:8:{s:5:\"title\";s:32:\"دسته بندی محصولات\";s:7:\"orderby\";s:4:\"name\";s:8:\"dropdown\";i:0;s:5:\"count\";i:0;s:12:\"hierarchical\";i:1;s:18:\"show_children_only\";i:0;s:10:\"hide_empty\";i:0;s:9:\"max_depth\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("278", "widget_woocommerce_product_search", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("279", "widget_woocommerce_product_tag_cloud", "a:2:{s:12:\"_multiwidget\";i:1;i:3;a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("280", "widget_woocommerce_products", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("281", "widget_woocommerce_recently_viewed_products", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("282", "widget_woocommerce_top_rated_products", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("283", "widget_woocommerce_recent_reviews", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("284", "widget_woocommerce_rating_filter", "a:2:{i:2;a:1:{s:5:\"title\";s:36:\"میانگین رای (امتیاز)\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("288", "woocommerce_meta_box_errors", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("297", "woocommerce_product_type", "both", "yes");
INSERT INTO `wp_options` VALUES("298", "woocommerce_allow_tracking", "yes", "yes");
INSERT INTO `wp_options` VALUES("300", "woocommerce_tracker_last_send", "1544422198", "yes");
INSERT INTO `wp_options` VALUES("309", "woocommerce_cheque_settings", "a:1:{s:7:\"enabled\";s:2:\"no\";}", "yes");
INSERT INTO `wp_options` VALUES("310", "woocommerce_bacs_settings", "a:1:{s:7:\"enabled\";s:2:\"no\";}", "yes");
INSERT INTO `wp_options` VALUES("311", "woocommerce_cod_settings", "a:1:{s:7:\"enabled\";s:2:\"no\";}", "yes");
INSERT INTO `wp_options` VALUES("313", "_transient_shipping-transient-version", "1543808349", "yes");
INSERT INTO `wp_options` VALUES("328", "_transient_timeout_wc_shipping_method_count_1_1543808349", "1546400762", "no");
INSERT INTO `wp_options` VALUES("329", "_transient_wc_shipping_method_count_1_1543808349", "0", "no");
INSERT INTO `wp_options` VALUES("331", "_transient_timeout_wc_shipping_method_count_0_1543808349", "1546400787", "no");
INSERT INTO `wp_options` VALUES("332", "_transient_wc_shipping_method_count_0_1543808349", "0", "no");
INSERT INTO `wp_options` VALUES("336", "_transient_product_query-transient-version", "1543810783", "yes");
INSERT INTO `wp_options` VALUES("342", "_transient_product-transient-version", "1543810783", "yes");
INSERT INTO `wp_options` VALUES("354", "product_cat_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("366", "_transient_orders-transient-version", "1543809514", "yes");
INSERT INTO `wp_options` VALUES("367", "_transient_timeout_wc_cbp_08d449c695767a4831932bb288378f56", "1546401514", "no");
INSERT INTO `wp_options` VALUES("368", "_transient_wc_cbp_08d449c695767a4831932bb288378f56", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("371", "_transient_as_comment_count", "O:8:\"stdClass\":7:{s:8:\"approved\";s:1:\"2\";s:14:\"total_comments\";i:2;s:3:\"all\";i:2;s:9:\"moderated\";i:0;s:4:\"spam\";i:0;s:5:\"trash\";i:0;s:12:\"post-trashed\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("420", "_transient_wc_count_comments", "O:8:\"stdClass\":7:{s:14:\"total_comments\";i:2;s:3:\"all\";i:2;s:8:\"approved\";s:1:\"2\";s:9:\"moderated\";i:0;s:4:\"spam\";i:0;s:5:\"trash\";i:0;s:12:\"post-trashed\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("437", "_transient_timeout_wc_term_counts", "1546403351", "no");
INSERT INTO `wp_options` VALUES("438", "_transient_wc_term_counts", "a:7:{i:18;s:1:\"8\";i:19;s:1:\"8\";i:21;s:1:\"2\";i:15;s:0:\"\";i:17;s:1:\"8\";i:16;s:1:\"8\";i:20;s:1:\"6\";}", "no");
INSERT INTO `wp_options` VALUES("439", "woocommerce_maybe_regenerate_images_hash", "991b1ca641921cf0f5baf7a2fe85861b", "yes");
INSERT INTO `wp_options` VALUES("475", "_transient_timeout_wc_low_stock_count", "1546403575", "no");
INSERT INTO `wp_options` VALUES("476", "_transient_wc_low_stock_count", "0", "no");
INSERT INTO `wp_options` VALUES("477", "_transient_timeout_wc_outofstock_count", "1546403576", "no");
INSERT INTO `wp_options` VALUES("478", "_transient_wc_outofstock_count", "0", "no");
INSERT INTO `wp_options` VALUES("489", "_transient_timeout_wc_product_loop42d91543810783", "1546404014", "no");
INSERT INTO `wp_options` VALUES("490", "_transient_wc_product_loop42d91543810783", "O:8:\"stdClass\":5:{s:3:\"ids\";a:4:{i:0;i:21;i:1;i:20;i:2;i:19;i:3;i:18;}s:5:\"total\";i:4;s:11:\"total_pages\";i:1;s:8:\"per_page\";i:4;s:12:\"current_page\";i:1;}", "no");
INSERT INTO `wp_options` VALUES("491", "_transient_timeout_wc_product_loopf8571543810783", "1546404014", "no");
INSERT INTO `wp_options` VALUES("492", "_transient_wc_product_loopf8571543810783", "O:8:\"stdClass\":5:{s:3:\"ids\";a:1:{i:0;i:15;}s:5:\"total\";i:1;s:11:\"total_pages\";i:1;s:8:\"per_page\";i:4;s:12:\"current_page\";i:1;}", "no");
INSERT INTO `wp_options` VALUES("493", "_transient_timeout_wc_product_loopa47f1543810783", "1546404015", "no");
INSERT INTO `wp_options` VALUES("494", "_transient_wc_product_loopa47f1543810783", "O:8:\"stdClass\":5:{s:3:\"ids\";a:4:{i:0;i:18;i:1;i:19;i:2;i:20;i:3;i:21;}s:5:\"total\";i:4;s:11:\"total_pages\";i:1;s:8:\"per_page\";i:4;s:12:\"current_page\";i:1;}", "no");
INSERT INTO `wp_options` VALUES("502", "_transient_timeout_external_ip_address_127.0.0.1", "1545026967", "no");
INSERT INTO `wp_options` VALUES("503", "_transient_external_ip_address_127.0.0.1", "83.123.163.186", "no");
INSERT INTO `wp_options` VALUES("506", "_site_transient_timeout_theme_roots", "1544424671", "no");
INSERT INTO `wp_options` VALUES("507", "_site_transient_theme_roots", "a:3:{s:6:\"jstore\";s:7:\"/themes\";s:14:\"twentynineteen\";s:7:\"/themes\";s:15:\"twentyseventeen\";s:7:\"/themes\";}", "no");
INSERT INTO `wp_options` VALUES("508", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1544422874;s:7:\"checked\";a:3:{s:6:\"jstore\";s:5:\"1.4.4\";s:14:\"twentynineteen\";s:3:\"1.0\";s:15:\"twentyseventeen\";s:3:\"1.7\";}s:8:\"response\";a:1:{s:15:\"twentyseventeen\";a:4:{s:5:\"theme\";s:15:\"twentyseventeen\";s:11:\"new_version\";s:3:\"1.8\";s:3:\"url\";s:45:\"https://wordpress.org/themes/twentyseventeen/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/theme/twentyseventeen.1.8.zip\";}}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("513", "_site_transient_timeout_browser_cd925ed22c52c50c3d7a2ca043e2bda8", "1545027414", "no");
INSERT INTO `wp_options` VALUES("514", "_site_transient_browser_cd925ed22c52c50c3d7a2ca043e2bda8", "a:10:{s:4:\"name\";s:7:\"Firefox\";s:7:\"version\";s:4:\"63.0\";s:8:\"platform\";s:7:\"Windows\";s:10:\"update_url\";s:24:\"https://www.firefox.com/\";s:7:\"img_src\";s:44:\"http://s.w.org/images/browsers/firefox.png?1\";s:11:\"img_src_ssl\";s:45:\"https://s.w.org/images/browsers/firefox.png?1\";s:15:\"current_version\";s:2:\"56\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}", "no");
INSERT INTO `wp_options` VALUES("515", "_transient_timeout_wc_report_sales_by_date", "1544509016", "no");
INSERT INTO `wp_options` VALUES("516", "_transient_wc_report_sales_by_date", "a:8:{s:32:\"136110433108742a6dde3305f41dade5\";a:0:{}s:32:\"f0536587de007fc30abe85c18e8b622c\";a:0:{}s:32:\"90d6c3e1dabe00fd3585d71b1adf23e5\";a:0:{}s:32:\"279e12fb729698893e212f5a742d69bd\";N;s:32:\"c98fa6acda2747fdbfc6e0775dee45b0\";a:0:{}s:32:\"5c257abf4240f173edea4858d62dfd93\";a:0:{}s:32:\"b00344082a0b9cfabb36b8395b6a7420\";a:0:{}s:32:\"15ee225adce6a82b187eaa104227c5a6\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("517", "_transient_timeout_wc_admin_report", "1544509016", "no");
INSERT INTO `wp_options` VALUES("518", "_transient_wc_admin_report", "a:1:{s:32:\"20573ac3a031b15150abdb9f38b465cd\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("519", "_site_transient_timeout_community-events-1aecf33ab8525ff212ebdffbb438372e", "1544465836", "no");
INSERT INTO `wp_options` VALUES("520", "_site_transient_community-events-1aecf33ab8525ff212ebdffbb438372e", "a:2:{s:8:\"location\";a:1:{s:2:\"ip\";s:9:\"127.0.0.0\";}s:6:\"events\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("521", "_transient_timeout_feed_1e2ffee29b94cfb5d3816e721235f11e", "1544465838", "no");
INSERT INTO `wp_options` VALUES("522", "_transient_feed_1e2ffee29b94cfb5d3816e721235f11e", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://wp-persian.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"وبگاه (وب سایت) رسمی پروژه وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"\n	Thu, 09 Aug 2018 16:01:04 +0000	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"fa-IR\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wordpress.org/?v=5.1-alpha-43678\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۹٫۸\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1397/05/18/wp-persian-498/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 09 Aug 2018 16:01:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=470\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:129:\"وردپرس فارسی ۴٫۹٫۸ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"<p>وردپرس فارسی ۴٫۹٫۸ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۹٫۱\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1396/10/24/wp-persian-491/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 14 Jan 2018 15:24:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=466\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:199:\"وردپرس فارسی ۴٫۹٫۱ منتشر شد. ترجمه این نگارش بدون نظارت مستقیم گروه وردپرس فارسی و توسط کاربران انجام شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:214:\"<p>وردپرس فارسی ۴٫۹٫۱ منتشر شد.</p>\n<p>ترجمه این نگارش بدون نظارت مستقیم گروه وردپرس فارسی و توسط کاربران انجام شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۸٫۲\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1396/07/14/wp-persian-482/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Oct 2017 08:29:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=464\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:129:\"وردپرس فارسی ۴٫۸٫۲ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"<p>وردپرس فارسی ۴٫۸٫۲ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۸٫۱\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1396/06/09/wp-persian-481/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 31 Aug 2017 09:55:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=461\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:129:\"وردپرس فارسی ۴٫۸٫۱ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"<p>وردپرس فارسی ۴٫۸٫۱ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"وردپرس فارسی ۴٫۸ نگارش استاد «آی‌محمد یوسفی»\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wp-persian.com/1396/03/19/wp-persian-48/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Jun 2017 16:13:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=458\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:576:\"وردپرس فارسی ۴٫۸ منتشر شد. این نگارش از وردپرس فارسی با افتخار مزیّن به نام استاد گرانقدر موسیقی ایران، «آی‌محمد یوسفی» است. می‌توانید نگارش جدید وردپرس فارسی را از این بخش دریافت٬ یا به‌صورت خودکار از بخش مدیریت سایت خود٬ به‌روز نمایید. توجه داشته باشید که پیغام به‌روزرسانی در بخش مدیریت سایت شما باید مربوط [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:816:\"<p>وردپرس فارسی ۴٫۸ منتشر شد.<br />\nاین نگارش از وردپرس فارسی با افتخار مزیّن به نام استاد گرانقدر موسیقی ایران، «<a href=\"https://fa.wikipedia.org/wiki/%D8%A2%DB%8C%E2%80%8C%D9%85%D8%AD%D9%85%D8%AF_%DB%8C%D9%88%D8%B3%D9%81%DB%8C\">آی‌محمد یوسفی</a>» است.</p>\n<p>می‌توانید نگارش جدید وردپرس فارسی را از <a href=\"http://wp-persian.com/download/\">این بخش</a> دریافت٬ یا به‌صورت خودکار از بخش مدیریت سایت خود٬ به‌روز نمایید.<br />\n<em>توجه داشته باشید که پیغام به‌روزرسانی در بخش مدیریت سایت شما باید مربوط به وردپرس فارسی (fa_IR) باشد.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۷٫۵\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1396/03/17/wp-persian-475/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Jun 2017 17:58:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=456\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:129:\"وردپرس فارسی ۴٫۷٫۵ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"<p>وردپرس فارسی ۴٫۷٫۵ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۷٫۴\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1396/02/06/wp-persian-474/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 26 Apr 2017 15:41:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=454\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"وردپرس فارسی ۴٫۷٫۴ منتشر شد. در این نگارش چند مشکل کوچک برطرف شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:133:\"<p>وردپرس فارسی ۴٫۷٫۴ منتشر شد. در این نگارش چند مشکل کوچک برطرف شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۷٫۳\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1396/01/05/wp-persian-473/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 25 Mar 2017 08:58:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=452\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:129:\"وردپرس فارسی ۴٫۷٫۳ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"<p>وردپرس فارسی ۴٫۷٫۳ منتشر شد. در این نگارش چند مشکل امنیتی برطرف شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۷٫۲\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1395/11/08/wp-persian-472/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Jan 2017 22:07:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=450\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:136:\"وردپرس فارسی ۴٫۷٫۲ منتشر شد. در این نگارش چند مشکل امنیتی مهم برطرف شده است.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"<p>وردپرس فارسی ۴٫۷٫۲ منتشر شد. در این نگارش چند مشکل امنیتی مهم برطرف شده است.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:48:\"\n		\n		\n				\n		\n				\n\n		\n				\n								\n										\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"وردپرس فارسی ۴٫۷٫۱\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wp-persian.com/1395/10/29/wp-persian-471/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 18 Jan 2017 15:14:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"وردپرس فارسی\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wp-persian.com/?p=448\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:549:\"وردپرس فارسی ۴٫۷٫۱ منتشر شد. در این نگارش چند مشکل امنیتی مهم برطرف شده است. می‌توانید نگارش جدید وردپرس فارسی را از این بخش دریافت٬ یا به‌صورت خودکار از بخش مدیریت سایت خود٬ به‌روز نمایید. توجه داشته باشید که پیغام به‌روزرسانی در بخش مدیریت سایت شما باید مربوط به وردپرس فارسی (fa_IR) باشد. در صورتی [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"گناهکار\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:820:\"<p>وردپرس فارسی ۴٫۷٫۱ منتشر شد. در این نگارش چند مشکل امنیتی مهم برطرف شده است.</p>\n<p>می‌توانید نگارش جدید وردپرس فارسی را از <a href=\"http://wp-persian.com/download/\">این بخش</a> دریافت٬ یا به‌صورت خودکار از بخش مدیریت سایت خود٬ به‌روز نمایید.<br />\n<em>توجه داشته باشید که پیغام به‌روزرسانی در بخش مدیریت سایت شما باید مربوط به وردپرس فارسی (fa_IR) باشد.</em><br />\nدر صورتی که پس از به‌روزرسانی خودکار برخی عناصر متحرک بخش مدیریت از کار افتادند، وردپرس را به‌صورت دستی به‌روز کنید.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:27:\"http://wp-persian.com/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:4:\"date\";s:29:\"Mon, 10 Dec 2018 06:17:17 GMT\";s:6:\"server\";s:6:\"Apache\";s:12:\"x-powered-by\";s:10:\"PHP/5.6.38\";s:4:\"link\";s:58:\"<http://wp-persian.com/wp-json/>; rel=\"https://api.w.org/\"\";s:7:\"upgrade\";s:6:\"h2,h2c\";s:13:\"last-modified\";s:29:\"Thu, 09 Aug 2018 16:01:04 GMT\";s:4:\"etag\";s:34:\"\"51bcc1d43f0902edc606cecb2a954741\"\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";}}s:5:\"build\";s:14:\"20130911003210\";}", "no");
INSERT INTO `wp_options` VALUES("523", "_transient_timeout_feed_mod_1e2ffee29b94cfb5d3816e721235f11e", "1544465838", "no");
INSERT INTO `wp_options` VALUES("524", "_transient_feed_mod_1e2ffee29b94cfb5d3816e721235f11e", "1544422638", "no");
INSERT INTO `wp_options` VALUES("525", "_transient_timeout_dash_v2_ccb55a4e4b351a220e50ef4117d7dc27", "1544465840", "no");
INSERT INTO `wp_options` VALUES("526", "_transient_dash_v2_ccb55a4e4b351a220e50ef4117d7dc27", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wp-persian.com/1397/05/18/wp-persian-498/\'>وردپرس فارسی ۴٫۹٫۸</a></li></ul></div><div class=\"rss-widget\"><p><strong>خطای RSS:</strong> WP HTTP Error: نشانی معتبر نیست.</p></div>", "no");
INSERT INTO `wp_options` VALUES("527", "_transient_timeout__woocommerce_helper_subscriptions", "1544423544", "no");
INSERT INTO `wp_options` VALUES("528", "_transient__woocommerce_helper_subscriptions", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("529", "_transient_timeout__woocommerce_helper_updates", "1544465844", "no");
INSERT INTO `wp_options` VALUES("530", "_transient__woocommerce_helper_updates", "a:4:{s:4:\"hash\";s:32:\"d751713988987e9331980363e24189ce\";s:7:\"updated\";i:1544422644;s:8:\"products\";a:0:{}s:6:\"errors\";a:1:{i:0;s:10:\"http-error\";}}", "no");
INSERT INTO `wp_options` VALUES("532", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("534", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.0.zip\";s:6:\"locale\";s:5:\"fa_IR\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-5.0.zip\";s:10:\"no_content\";s:68:\"https://downloads.wordpress.org/release/wordpress-5.0-no-content.zip\";s:11:\"new_bundled\";s:69:\"https://downloads.wordpress.org/release/wordpress-5.0-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"5.0\";s:7:\"version\";s:3:\"5.0\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.0\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1544422870;s:15:\"version_checked\";s:3:\"5.0\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("536", "can_compress_scripts", "1", "no");
INSERT INTO `wp_options` VALUES("540", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1544422890;s:7:\"checked\";a:4:{s:33:\"classic-editor/classic-editor.php\";s:3:\"1.2\";s:25:\"duplicator/duplicator.php\";s:6:\"1.2.52\";s:41:\"theme-data-importor-by-phoeniixx/main.php\";s:5:\"1.0.9\";s:27:\"woocommerce/woocommerce.php\";s:5:\"3.5.2\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:4:{s:33:\"classic-editor/classic-editor.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:28:\"w.org/plugins/classic-editor\";s:4:\"slug\";s:14:\"classic-editor\";s:6:\"plugin\";s:33:\"classic-editor/classic-editor.php\";s:11:\"new_version\";s:3:\"1.2\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/classic-editor/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/classic-editor.1.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/classic-editor/assets/icon-256x256.png?rev=1750045\";s:2:\"1x\";s:67:\"https://ps.w.org/classic-editor/assets/icon-128x128.png?rev=1750045\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/classic-editor/assets/banner-1544x500.png?rev=1750404\";s:2:\"1x\";s:69:\"https://ps.w.org/classic-editor/assets/banner-772x250.png?rev=1751803\";}s:11:\"banners_rtl\";a:0:{}}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:24:\"w.org/plugins/duplicator\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:6:\"1.2.52\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/duplicator.1.2.52.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/duplicator/assets/icon-256x256.png?rev=1298463\";s:2:\"1x\";s:63:\"https://ps.w.org/duplicator/assets/icon-128x128.png?rev=1298463\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/duplicator/assets/banner-772x250.png?rev=1645055\";}s:11:\"banners_rtl\";a:0:{}}s:41:\"theme-data-importor-by-phoeniixx/main.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:46:\"w.org/plugins/theme-data-importor-by-phoeniixx\";s:4:\"slug\";s:32:\"theme-data-importor-by-phoeniixx\";s:6:\"plugin\";s:41:\"theme-data-importor-by-phoeniixx/main.php\";s:11:\"new_version\";s:5:\"1.0.9\";s:3:\"url\";s:63:\"https://wordpress.org/plugins/theme-data-importor-by-phoeniixx/\";s:7:\"package\";s:81:\"https://downloads.wordpress.org/plugin/theme-data-importor-by-phoeniixx.1.0.9.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:76:\"https://s.w.org/plugins/geopattern-icon/theme-data-importor-by-phoeniixx.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}}s:27:\"woocommerce/woocommerce.php\";O:8:\"stdClass\":9:{s:2:\"id\";s:25:\"w.org/plugins/woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:6:\"plugin\";s:27:\"woocommerce/woocommerce.php\";s:11:\"new_version\";s:5:\"3.5.2\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/woocommerce/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/woocommerce.3.5.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/woocommerce/assets/icon-256x256.png?rev=1440831\";s:2:\"1x\";s:64:\"https://ps.w.org/woocommerce/assets/icon-128x128.png?rev=1440831\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/woocommerce/assets/banner-1544x500.png?rev=1629184\";s:2:\"1x\";s:66:\"https://ps.w.org/woocommerce/assets/banner-772x250.png?rev=1629184\";}s:11:\"banners_rtl\";a:0:{}}}}", "no");
INSERT INTO `wp_options` VALUES("541", "_transient_timeout_plugin_slugs", "1544509434", "no");
INSERT INTO `wp_options` VALUES("542", "_transient_plugin_slugs", "a:4:{i:0;s:33:\"classic-editor/classic-editor.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:41:\"theme-data-importor-by-phoeniixx/main.php\";i:3;s:27:\"woocommerce/woocommerce.php\";}", "no");
INSERT INTO `wp_options` VALUES("544", "_transient_is_multi_author", "0", "yes");
INSERT INTO `wp_options` VALUES("546", "_transient_jstore_categories", "1", "yes");
INSERT INTO `wp_options` VALUES("547", "_transient_timeout_wc_related_20", "1544509416", "no");
INSERT INTO `wp_options` VALUES("548", "_transient_wc_related_20", "a:1:{s:72:\"limit=4&exclude_ids%5B0%5D=0&exclude_ids%5B1%5D=20&exclude_ids%5B2%5D=10\";a:6:{i:0;s:2:\"15\";i:1;s:2:\"16\";i:2;s:2:\"17\";i:3;s:2:\"18\";i:4;s:2:\"19\";i:5;s:2:\"21\";}}", "no");
INSERT INTO `wp_options` VALUES("549", "duplicator_settings", "a:10:{s:7:\"version\";s:6:\"1.2.52\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:1;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("550", "duplicator_version_plugin", "1.2.52", "yes");
INSERT INTO `wp_options` VALUES("553", "duplicator_package_active", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2018-12-10 06:26:51\";s:7:\"Version\";s:6:\"1.2.52\";s:9:\"VersionWP\";s:3:\"5.0\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:6:\"jstore\";s:4:\"Hash\";s:35:\"5758f6ab4fa6dde47394_20181210062651\";s:8:\"NameHash\";s:42:\"jstore_5758f6ab4fa6dde47394_20181210062651\";s:4:\"Type\";i:0;s:5:\"Notes\";s:57:\"jstore wordpress theme install packages by iranthemes.com\";s:9:\"StorePath\";s:47:\"G:/Program Files/wamp/www/demo/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://localhost/demo/wp-snapshots/\";s:8:\"ScanFile\";s:52:\"jstore_5758f6ab4fa6dde47394_20181210062651_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":19:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:30:\"G:/Program Files/wamp/www/demo\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":4:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":5:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":2:{s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2018-12-10 06:26:51\";s:7:\"Version\";s:6:\"1.2.52\";s:9:\"VersionWP\";s:3:\"5.0\";s:9:\"VersionDB\";s:6:\"5.6.17\";s:10:\"VersionPHP\";s:6:\"5.5.12\";s:9:\"VersionOS\";s:5:\"WINNT\";s:2:\"ID\";N;s:4:\"Name\";s:6:\"jstore\";s:4:\"Hash\";s:35:\"5758f6ab4fa6dde47394_20181210062651\";s:8:\"NameHash\";s:42:\"jstore_5758f6ab4fa6dde47394_20181210062651\";s:4:\"Type\";i:0;s:5:\"Notes\";s:57:\"jstore wordpress theme install packages by iranthemes.com\";s:9:\"StorePath\";s:47:\"G:/Program Files/wamp/www/demo/wp-snapshots/tmp\";s:8:\"StoreURL\";s:35:\"http://localhost/demo/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";r:22;s:9:\"Installer\";O:13:\"DUP_Installer\":9:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:10:\"\0*\0Package\";r:58;}s:8:\"Database\";O:12:\"DUP_Database\":13:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:10:\"\0*\0Package\";r:58;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:6:{i:0;s:39:\"G:/Program Files/wamp/www/demo/wp-admin\";i:1;s:49:\"G:/Program Files/wamp/www/demo/wp-content/uploads\";i:2;s:51:\"G:/Program Files/wamp/www/demo/wp-content/languages\";i:3;s:49:\"G:/Program Files/wamp/www/demo/wp-content/plugins\";i:4;s:48:\"G:/Program Files/wamp/www/demo/wp-content/themes\";i:5;s:42:\"G:/Program Files/wamp/www/demo/wp-includes\";}}s:9:\"Installer\";r:80;s:8:\"Database\";r:90;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("2", "3", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("3", "2", "_edit_lock", "1543808606:1");
INSERT INTO `wp_postmeta` VALUES("4", "2", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("5", "10", "_wc_review_count", "0");
INSERT INTO `wp_postmeta` VALUES("6", "10", "_wc_rating_count", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("7", "10", "_wc_average_rating", "0");
INSERT INTO `wp_postmeta` VALUES("8", "10", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("9", "10", "_edit_lock", "1543809118:1");
INSERT INTO `wp_postmeta` VALUES("10", "11", "_wp_attached_file", "2018/12/ds.png");
INSERT INTO `wp_postmeta` VALUES("11", "11", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:600;s:4:\"file\";s:14:\"2018/12/ds.png\";s:5:\"sizes\";a:12:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:14:\"ds-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:14:\"ds-300x225.png\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:14:\"ds-768x576.png\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"jstore-featured\";a:4:{s:4:\"file\";s:14:\"ds-800x600.png\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:9:\"image/png\";}s:22:\"jstore-featured-single\";a:4:{s:4:\"file\";s:14:\"ds-800x600.png\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:14:\"ds-800x510.png\";s:5:\"width\";i:800;s:6:\"height\";i:510;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:14:\"ds-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";s:9:\"uncropped\";b:1;}s:18:\"woocommerce_single\";a:4:{s:4:\"file\";s:14:\"ds-600x450.png\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:9:\"image/png\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:14:\"ds-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:14:\"ds-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";s:9:\"uncropped\";b:1;}s:11:\"shop_single\";a:4:{s:4:\"file\";s:14:\"ds-600x450.png\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:14:\"ds-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("12", "12", "_wp_attached_file", "2018/12/how-to-hire-a-wordpress-developer.png");
INSERT INTO `wp_postmeta` VALUES("13", "12", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:600;s:4:\"file\";s:45:\"2018/12/how-to-hire-a-wordpress-developer.png\";s:5:\"sizes\";a:12:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-300x225.png\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-768x576.png\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"jstore-featured\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-800x600.png\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:9:\"image/png\";}s:22:\"jstore-featured-single\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-800x600.png\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-800x510.png\";s:5:\"width\";i:800;s:6:\"height\";i:510;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";s:9:\"uncropped\";b:1;}s:18:\"woocommerce_single\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-600x450.png\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:9:\"image/png\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";s:9:\"uncropped\";b:1;}s:11:\"shop_single\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-600x450.png\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:45:\"how-to-hire-a-wordpress-developer-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("14", "13", "_wp_attached_file", "2018/12/open-shop-01.png");
INSERT INTO `wp_postmeta` VALUES("15", "13", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:600;s:4:\"file\";s:24:\"2018/12/open-shop-01.png\";s:5:\"sizes\";a:12:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"open-shop-01-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"open-shop-01-300x225.png\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"open-shop-01-768x576.png\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:9:\"image/png\";}s:15:\"jstore-featured\";a:4:{s:4:\"file\";s:24:\"open-shop-01-800x600.png\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:9:\"image/png\";}s:22:\"jstore-featured-single\";a:4:{s:4:\"file\";s:24:\"open-shop-01-800x600.png\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:24:\"open-shop-01-800x510.png\";s:5:\"width\";i:800;s:6:\"height\";i:510;s:9:\"mime-type\";s:9:\"image/png\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:24:\"open-shop-01-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";s:9:\"uncropped\";b:1;}s:18:\"woocommerce_single\";a:4:{s:4:\"file\";s:24:\"open-shop-01-600x450.png\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:9:\"image/png\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:24:\"open-shop-01-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:24:\"open-shop-01-300x300.png\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:9:\"image/png\";s:9:\"uncropped\";b:1;}s:11:\"shop_single\";a:4:{s:4:\"file\";s:24:\"open-shop-01-600x450.png\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:24:\"open-shop-01-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("16", "14", "_wp_attached_file", "2018/12/shopping_cart.jpg");
INSERT INTO `wp_postmeta` VALUES("17", "14", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:600;s:4:\"file\";s:25:\"2018/12/shopping_cart.jpg\";s:5:\"sizes\";a:12:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"shopping_cart-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"shopping_cart-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"shopping_cart-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"jstore-featured\";a:4:{s:4:\"file\";s:25:\"shopping_cart-800x600.jpg\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"jstore-featured-single\";a:4:{s:4:\"file\";s:25:\"shopping_cart-800x600.jpg\";s:5:\"width\";i:800;s:6:\"height\";i:600;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:25:\"shopping_cart-800x510.jpg\";s:5:\"width\";i:800;s:6:\"height\";i:510;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:25:\"shopping_cart-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:18:\"woocommerce_single\";a:4:{s:4:\"file\";s:25:\"shopping_cart-600x450.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:25:\"shopping_cart-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:25:\"shopping_cart-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:11:\"shop_single\";a:4:{s:4:\"file\";s:25:\"shopping_cart-600x450.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:450;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:25:\"shopping_cart-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("18", "10", "_thumbnail_id", "11");
INSERT INTO `wp_postmeta` VALUES("19", "10", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("20", "10", "_regular_price", "50000");
INSERT INTO `wp_postmeta` VALUES("21", "10", "_sale_price", "40000");
INSERT INTO `wp_postmeta` VALUES("22", "10", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("23", "10", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("24", "10", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("25", "10", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("26", "10", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("27", "10", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("28", "10", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("29", "10", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("30", "10", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("31", "10", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("32", "10", "_length", "");
INSERT INTO `wp_postmeta` VALUES("33", "10", "_width", "");
INSERT INTO `wp_postmeta` VALUES("34", "10", "_height", "");
INSERT INTO `wp_postmeta` VALUES("35", "10", "_upsell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("36", "10", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("37", "10", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("38", "10", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("39", "10", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("40", "10", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("41", "10", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("42", "10", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("43", "10", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("44", "10", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("45", "10", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("46", "10", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("47", "10", "_price", "40000");
INSERT INTO `wp_postmeta` VALUES("48", "10", "_wp_old_slug", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d8%aa%d8%b3%d8%aa%db%8c-%d8%a7%d9%88%d9%84");
INSERT INTO `wp_postmeta` VALUES("49", "15", "_wc_review_count", "1");
INSERT INTO `wp_postmeta` VALUES("50", "15", "_wc_rating_count", "a:1:{i:5;i:1;}");
INSERT INTO `wp_postmeta` VALUES("51", "15", "_wc_average_rating", "5.00");
INSERT INTO `wp_postmeta` VALUES("52", "15", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("53", "15", "_edit_lock", "1543809342:1");
INSERT INTO `wp_postmeta` VALUES("54", "15", "_thumbnail_id", "12");
INSERT INTO `wp_postmeta` VALUES("55", "15", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("56", "15", "_regular_price", "50000");
INSERT INTO `wp_postmeta` VALUES("57", "15", "_sale_price", "");
INSERT INTO `wp_postmeta` VALUES("58", "15", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("59", "15", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("60", "15", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("61", "15", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("62", "15", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("63", "15", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("64", "15", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("65", "15", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("66", "15", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("67", "15", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("68", "15", "_length", "");
INSERT INTO `wp_postmeta` VALUES("69", "15", "_width", "");
INSERT INTO `wp_postmeta` VALUES("70", "15", "_height", "");
INSERT INTO `wp_postmeta` VALUES("71", "15", "_upsell_ids", "a:1:{i:0;i:10;}");
INSERT INTO `wp_postmeta` VALUES("72", "15", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("73", "15", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("74", "15", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("75", "15", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("76", "15", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("77", "15", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("78", "15", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("79", "15", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("80", "15", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("81", "15", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("82", "15", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("83", "15", "_price", "50000");
INSERT INTO `wp_postmeta` VALUES("84", "16", "_wc_review_count", "0");
INSERT INTO `wp_postmeta` VALUES("85", "16", "_wc_rating_count", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("86", "16", "_wc_average_rating", "0");
INSERT INTO `wp_postmeta` VALUES("87", "16", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("88", "16", "_edit_lock", "1543809527:1");
INSERT INTO `wp_postmeta` VALUES("89", "16", "_thumbnail_id", "13");
INSERT INTO `wp_postmeta` VALUES("90", "16", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("91", "16", "_regular_price", "25000");
INSERT INTO `wp_postmeta` VALUES("92", "16", "_sale_price", "");
INSERT INTO `wp_postmeta` VALUES("93", "16", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("94", "16", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("95", "16", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("96", "16", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("97", "16", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("98", "16", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("99", "16", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("100", "16", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("101", "16", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("102", "16", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("103", "16", "_length", "");
INSERT INTO `wp_postmeta` VALUES("104", "16", "_width", "");
INSERT INTO `wp_postmeta` VALUES("105", "16", "_height", "");
INSERT INTO `wp_postmeta` VALUES("106", "16", "_upsell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("107", "16", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("108", "16", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("109", "16", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("110", "16", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("111", "16", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("112", "16", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("113", "16", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("114", "16", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("115", "16", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("116", "16", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("117", "16", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("118", "16", "_price", "25000");
INSERT INTO `wp_postmeta` VALUES("119", "17", "_wc_review_count", "0");
INSERT INTO `wp_postmeta` VALUES("120", "17", "_wc_rating_count", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("121", "17", "_wc_average_rating", "0");
INSERT INTO `wp_postmeta` VALUES("122", "17", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("123", "17", "_edit_lock", "1543810235:1");
INSERT INTO `wp_postmeta` VALUES("124", "17", "_thumbnail_id", "14");
INSERT INTO `wp_postmeta` VALUES("125", "17", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("126", "17", "_regular_price", "35000");
INSERT INTO `wp_postmeta` VALUES("127", "17", "_sale_price", "");
INSERT INTO `wp_postmeta` VALUES("128", "17", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("129", "17", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("130", "17", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("131", "17", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("132", "17", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("133", "17", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("134", "17", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("135", "17", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("136", "17", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("137", "17", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("138", "17", "_length", "");
INSERT INTO `wp_postmeta` VALUES("139", "17", "_width", "");
INSERT INTO `wp_postmeta` VALUES("140", "17", "_height", "");
INSERT INTO `wp_postmeta` VALUES("141", "17", "_upsell_ids", "a:3:{i:0;i:10;i:1;i:15;i:2;i:16;}");
INSERT INTO `wp_postmeta` VALUES("142", "17", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("143", "17", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("144", "17", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("145", "17", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("146", "17", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("147", "17", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("148", "17", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("149", "17", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("150", "17", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("151", "17", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("152", "17", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("153", "17", "_price", "35000");
INSERT INTO `wp_postmeta` VALUES("154", "18", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("155", "18", "_regular_price", "70000");
INSERT INTO `wp_postmeta` VALUES("156", "18", "_sale_price", "");
INSERT INTO `wp_postmeta` VALUES("157", "18", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("158", "18", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("159", "18", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("160", "18", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("161", "18", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("162", "18", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("163", "18", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("164", "18", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("165", "18", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("166", "18", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("167", "18", "_length", "");
INSERT INTO `wp_postmeta` VALUES("168", "18", "_width", "");
INSERT INTO `wp_postmeta` VALUES("169", "18", "_height", "");
INSERT INTO `wp_postmeta` VALUES("170", "18", "_upsell_ids", "a:3:{i:0;i:10;i:1;i:15;i:2;i:16;}");
INSERT INTO `wp_postmeta` VALUES("171", "18", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("172", "18", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("173", "18", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("174", "18", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("175", "18", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("176", "18", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("177", "18", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("178", "18", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("179", "18", "_thumbnail_id", "14");
INSERT INTO `wp_postmeta` VALUES("180", "18", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("181", "18", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("182", "18", "_wc_average_rating", "0");
INSERT INTO `wp_postmeta` VALUES("183", "18", "_wc_rating_count", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("184", "18", "_wc_review_count", "0");
INSERT INTO `wp_postmeta` VALUES("185", "18", "_downloadable_files", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("186", "18", "_product_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("187", "18", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("188", "18", "_price", "70000");
INSERT INTO `wp_postmeta` VALUES("189", "18", "_edit_lock", "1543810407:1");
INSERT INTO `wp_postmeta` VALUES("190", "18", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("191", "19", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("192", "19", "_regular_price", "95000");
INSERT INTO `wp_postmeta` VALUES("193", "19", "_sale_price", "");
INSERT INTO `wp_postmeta` VALUES("194", "19", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("195", "19", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("196", "19", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("197", "19", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("198", "19", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("199", "19", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("200", "19", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("201", "19", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("202", "19", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("203", "19", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("204", "19", "_length", "");
INSERT INTO `wp_postmeta` VALUES("205", "19", "_width", "");
INSERT INTO `wp_postmeta` VALUES("206", "19", "_height", "");
INSERT INTO `wp_postmeta` VALUES("207", "19", "_upsell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("208", "19", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("209", "19", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("210", "19", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("211", "19", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("212", "19", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("213", "19", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("214", "19", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("215", "19", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("216", "19", "_thumbnail_id", "13");
INSERT INTO `wp_postmeta` VALUES("217", "19", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("218", "19", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("219", "19", "_wc_average_rating", "0");
INSERT INTO `wp_postmeta` VALUES("220", "19", "_wc_rating_count", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("221", "19", "_wc_review_count", "0");
INSERT INTO `wp_postmeta` VALUES("222", "19", "_downloadable_files", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("223", "19", "_product_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("224", "19", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("225", "19", "_price", "95000");
INSERT INTO `wp_postmeta` VALUES("226", "19", "_edit_lock", "1543810492:1");
INSERT INTO `wp_postmeta` VALUES("227", "19", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("228", "20", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("229", "20", "_regular_price", "68000");
INSERT INTO `wp_postmeta` VALUES("230", "20", "_sale_price", "");
INSERT INTO `wp_postmeta` VALUES("231", "20", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("232", "20", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("233", "20", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("234", "20", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("235", "20", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("236", "20", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("237", "20", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("238", "20", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("239", "20", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("240", "20", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("241", "20", "_length", "");
INSERT INTO `wp_postmeta` VALUES("242", "20", "_width", "");
INSERT INTO `wp_postmeta` VALUES("243", "20", "_height", "");
INSERT INTO `wp_postmeta` VALUES("244", "20", "_upsell_ids", "a:1:{i:0;i:10;}");
INSERT INTO `wp_postmeta` VALUES("245", "20", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("246", "20", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("247", "20", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("248", "20", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("249", "20", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("250", "20", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("251", "20", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("252", "20", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("253", "20", "_thumbnail_id", "12");
INSERT INTO `wp_postmeta` VALUES("254", "20", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("255", "20", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("256", "20", "_wc_average_rating", "0");
INSERT INTO `wp_postmeta` VALUES("257", "20", "_wc_rating_count", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("258", "20", "_wc_review_count", "0");
INSERT INTO `wp_postmeta` VALUES("259", "20", "_downloadable_files", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("260", "20", "_product_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("261", "20", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("262", "20", "_price", "68000");
INSERT INTO `wp_postmeta` VALUES("263", "20", "_edit_lock", "1543810577:1");
INSERT INTO `wp_postmeta` VALUES("264", "20", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("265", "21", "_sku", "");
INSERT INTO `wp_postmeta` VALUES("266", "21", "_regular_price", "90000");
INSERT INTO `wp_postmeta` VALUES("267", "21", "_sale_price", "80000");
INSERT INTO `wp_postmeta` VALUES("268", "21", "_sale_price_dates_from", "");
INSERT INTO `wp_postmeta` VALUES("269", "21", "_sale_price_dates_to", "");
INSERT INTO `wp_postmeta` VALUES("270", "21", "total_sales", "0");
INSERT INTO `wp_postmeta` VALUES("271", "21", "_tax_status", "taxable");
INSERT INTO `wp_postmeta` VALUES("272", "21", "_tax_class", "");
INSERT INTO `wp_postmeta` VALUES("273", "21", "_manage_stock", "no");
INSERT INTO `wp_postmeta` VALUES("274", "21", "_backorders", "no");
INSERT INTO `wp_postmeta` VALUES("275", "21", "_low_stock_amount", "");
INSERT INTO `wp_postmeta` VALUES("276", "21", "_sold_individually", "no");
INSERT INTO `wp_postmeta` VALUES("277", "21", "_weight", "");
INSERT INTO `wp_postmeta` VALUES("278", "21", "_length", "");
INSERT INTO `wp_postmeta` VALUES("279", "21", "_width", "");
INSERT INTO `wp_postmeta` VALUES("280", "21", "_height", "");
INSERT INTO `wp_postmeta` VALUES("281", "21", "_upsell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("282", "21", "_crosssell_ids", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("283", "21", "_purchase_note", "");
INSERT INTO `wp_postmeta` VALUES("284", "21", "_default_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("285", "21", "_virtual", "no");
INSERT INTO `wp_postmeta` VALUES("286", "21", "_downloadable", "no");
INSERT INTO `wp_postmeta` VALUES("287", "21", "_product_image_gallery", "11,12,13,14");
INSERT INTO `wp_postmeta` VALUES("288", "21", "_download_limit", "-1");
INSERT INTO `wp_postmeta` VALUES("289", "21", "_download_expiry", "-1");
INSERT INTO `wp_postmeta` VALUES("290", "21", "_thumbnail_id", "11");
INSERT INTO `wp_postmeta` VALUES("291", "21", "_stock", NULL);
INSERT INTO `wp_postmeta` VALUES("292", "21", "_stock_status", "instock");
INSERT INTO `wp_postmeta` VALUES("293", "21", "_wc_average_rating", "0");
INSERT INTO `wp_postmeta` VALUES("294", "21", "_wc_rating_count", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("295", "21", "_wc_review_count", "0");
INSERT INTO `wp_postmeta` VALUES("296", "21", "_downloadable_files", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("297", "21", "_product_attributes", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("298", "21", "_product_version", "3.5.2");
INSERT INTO `wp_postmeta` VALUES("299", "21", "_price", "80000");
INSERT INTO `wp_postmeta` VALUES("300", "21", "_edit_lock", "1543811194:1");
INSERT INTO `wp_postmeta` VALUES("301", "21", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("302", "22", "_wp_attached_file", "2018/12/cropped-how-to-hire-a-wordpress-developer.png");
INSERT INTO `wp_postmeta` VALUES("303", "22", "_wp_attachment_context", "custom-logo");
INSERT INTO `wp_postmeta` VALUES("304", "22", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:248;s:6:\"height\";i:248;s:4:\"file\";s:53:\"2018/12/cropped-how-to-hire-a-wordpress-developer.png\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:53:\"cropped-how-to-hire-a-wordpress-developer-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:53:\"cropped-how-to-hire-a-wordpress-developer-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:53:\"cropped-how-to-hire-a-wordpress-developer-100x100.png\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("305", "23", "_edit_lock", "1543811252:1");
INSERT INTO `wp_postmeta` VALUES("306", "24", "_wp_attached_file", "2018/12/sbanner1-1-2.jpg");
INSERT INTO `wp_postmeta` VALUES("307", "24", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:374;s:6:\"height\";i:144;s:4:\"file\";s:24:\"2018/12/sbanner1-1-2.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner1-1-2-150x144.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"sbanner1-1-2-300x116.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:116;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:24:\"sbanner1-1-2-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner1-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:24:\"sbanner1-1-2-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner1-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("308", "25", "_wp_attached_file", "2018/12/sbanner3-1-2.jpg");
INSERT INTO `wp_postmeta` VALUES("309", "25", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:374;s:6:\"height\";i:144;s:4:\"file\";s:24:\"2018/12/sbanner3-1-2.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner3-1-2-150x144.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"sbanner3-1-2-300x116.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:116;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:24:\"sbanner3-1-2-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner3-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:24:\"sbanner3-1-2-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner3-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("310", "26", "_wp_attached_file", "2018/12/sbanner2-1-2.jpg");
INSERT INTO `wp_postmeta` VALUES("311", "26", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:374;s:6:\"height\";i:140;s:4:\"file\";s:24:\"2018/12/sbanner2-1-2.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner2-1-2-150x140.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"sbanner2-1-2-300x112.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:112;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:24:\"sbanner2-1-2-300x140.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner2-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:24:\"sbanner2-1-2-300x140.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:24:\"sbanner2-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("312", "27", "_wp_attached_file", "2018/12/01-2.jpg");
INSERT INTO `wp_postmeta` VALUES("313", "27", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:168;s:6:\"height\";i:86;s:4:\"file\";s:16:\"2018/12/01-2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:15:\"01-2-150x86.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"01-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"01-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("314", "28", "_wp_attached_file", "2018/12/02-2.jpg");
INSERT INTO `wp_postmeta` VALUES("315", "28", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:168;s:6:\"height\";i:86;s:4:\"file\";s:16:\"2018/12/02-2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:15:\"02-2-150x86.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"02-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"02-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("316", "29", "_wp_attached_file", "2018/12/03-2.jpg");
INSERT INTO `wp_postmeta` VALUES("317", "29", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:169;s:6:\"height\";i:86;s:4:\"file\";s:16:\"2018/12/03-2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:15:\"03-2-150x86.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"03-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"03-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("318", "30", "_wp_attached_file", "2018/12/04-2.jpg");
INSERT INTO `wp_postmeta` VALUES("319", "30", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:168;s:6:\"height\";i:86;s:4:\"file\";s:16:\"2018/12/04-2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:15:\"04-2-150x86.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"04-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"04-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("320", "31", "_wp_attached_file", "2018/12/06-2.jpg");
INSERT INTO `wp_postmeta` VALUES("321", "31", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:168;s:6:\"height\";i:86;s:4:\"file\";s:16:\"2018/12/06-2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:15:\"06-2-150x86.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"06-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"06-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("322", "32", "_wp_attached_file", "2018/12/07-2.jpg");
INSERT INTO `wp_postmeta` VALUES("323", "32", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:168;s:6:\"height\";i:86;s:4:\"file\";s:16:\"2018/12/07-2.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:15:\"07-2-150x86.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:15:\"07-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:15:\"07-2-100x86.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("324", "33", "_wp_attached_file", "2018/12/cropped-shopping_cart.jpg");
INSERT INTO `wp_postmeta` VALUES("325", "33", "_wp_attachment_context", "custom-header");
INSERT INTO `wp_postmeta` VALUES("326", "33", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:2000;s:6:\"height\";i:807;s:4:\"file\";s:33:\"2018/12/cropped-shopping_cart.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-300x121.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:121;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-768x310.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:310;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:34:\"cropped-shopping_cart-1024x413.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:413;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"jstore-featured\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-980x600.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:600;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"jstore-featured-single\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-980x600.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:600;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-825x510.jpg\";s:5:\"width\";i:825;s:6:\"height\";i:510;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:33:\"cropped-shopping_cart-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:18:\"woocommerce_single\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-600x242.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:242;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:5:{s:4:\"file\";s:33:\"cropped-shopping_cart-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:11:\"shop_single\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-600x242.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:242;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:33:\"cropped-shopping_cart-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("327", "33", "_wp_attachment_custom_header_last_used_jstore", "1543811286");
INSERT INTO `wp_postmeta` VALUES("328", "33", "_wp_attachment_is_custom_header", "jstore");
INSERT INTO `wp_postmeta` VALUES("329", "23", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("330", "23", "_wp_trash_meta_time", "1543811286");
INSERT INTO `wp_postmeta` VALUES("331", "34", "_edit_lock", "1543811700:1");
INSERT INTO `wp_postmeta` VALUES("332", "34", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("333", "34", "_wp_trash_meta_time", "1543811700");
INSERT INTO `wp_postmeta` VALUES("334", "35", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("335", "35", "_edit_lock", "1543811665:1");
INSERT INTO `wp_postmeta` VALUES("336", "35", "_wp_page_template", "template-front-page.php");
INSERT INTO `wp_postmeta` VALUES("337", "37", "_wp_attached_file", "2018/12/banner02-1-2.jpg");
INSERT INTO `wp_postmeta` VALUES("338", "37", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:673;s:4:\"file\";s:24:\"2018/12/banner02-1-2.jpg\";s:5:\"sizes\";a:13:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-300x105.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:105;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-768x269.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:269;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"banner02-1-2-1024x359.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:359;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:15:\"jstore-featured\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-980x600.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:600;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"jstore-featured-single\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-980x600.jpg\";s:5:\"width\";i:980;s:6:\"height\";i:600;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-825x510.jpg\";s:5:\"width\";i:825;s:6:\"height\";i:510;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:24:\"banner02-1-2-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:18:\"woocommerce_single\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-600x210.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:11:\"shop_single\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-600x210.jpg\";s:5:\"width\";i:600;s:6:\"height\";i:210;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:24:\"banner02-1-2-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("339", "38", "_wp_attached_file", "2018/12/sbanner1-1-2-1.jpg");
INSERT INTO `wp_postmeta` VALUES("340", "38", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:374;s:6:\"height\";i:144;s:4:\"file\";s:26:\"2018/12/sbanner1-1-2-1.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner1-1-2-1-150x144.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"sbanner1-1-2-1-300x116.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:116;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:26:\"sbanner1-1-2-1-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner1-1-2-1-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:26:\"sbanner1-1-2-1-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner1-1-2-1-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("341", "39", "_wp_attached_file", "2018/12/sbanner2-1-2-1.jpg");
INSERT INTO `wp_postmeta` VALUES("342", "39", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:374;s:6:\"height\";i:140;s:4:\"file\";s:26:\"2018/12/sbanner2-1-2-1.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner2-1-2-1-150x140.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"sbanner2-1-2-1-300x112.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:112;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:26:\"sbanner2-1-2-1-300x140.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner2-1-2-1-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:26:\"sbanner2-1-2-1-300x140.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner2-1-2-1-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("343", "40", "_wp_attached_file", "2018/12/sbanner3-1-2-1.jpg");
INSERT INTO `wp_postmeta` VALUES("344", "40", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:374;s:6:\"height\";i:144;s:4:\"file\";s:26:\"2018/12/sbanner3-1-2-1.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner3-1-2-1-150x144.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:26:\"sbanner3-1-2-1-300x116.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:116;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:21:\"woocommerce_thumbnail\";a:5:{s:4:\"file\";s:26:\"sbanner3-1-2-1-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";s:9:\"uncropped\";b:1;}s:29:\"woocommerce_gallery_thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner3-1-2-1-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"shop_catalog\";a:4:{s:4:\"file\";s:26:\"sbanner3-1-2-1-300x144.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:144;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"shop_thumbnail\";a:4:{s:4:\"file\";s:26:\"sbanner3-1-2-1-100x100.jpg\";s:5:\"width\";i:100;s:6:\"height\";i:100;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("345", "41", "_edit_lock", "1543812266:1");
INSERT INTO `wp_postmeta` VALUES("346", "41", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("347", "41", "_wp_trash_meta_time", "1543812269");
INSERT INTO `wp_postmeta` VALUES("348", "43", "_edit_lock", "1544422747:1");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2018-12-03 06:56:57", "2018-12-03 03:26:57", "به وردپرس فارسی خوش آمدید.‌ این نخستین نوشته‌‌ی شماست. می‌توانید ویرایش یا پاکش کنید و پس از آن نوشتن را آغاز کنید!", "سلام دنیا!", "", "publish", "open", "open", "", "%d8%b3%d9%84%d8%a7%d9%85-%d8%af%d9%86%db%8c%d8%a7", "", "", "2018-12-03 06:56:57", "2018-12-03 03:26:57", "", "0", "http://localhost/demo/?p=1", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("2", "1", "2018-12-03 06:56:57", "2018-12-03 03:26:57", "این یک برگه‌ی نمونه است که با یک نوشته در وبلاگ تفاوت دارد زیرا برگه‌ها در یک مکان ثابت می‌مانند و معمولاً در فهرست پیوندهای درونی سایت شما نمایش داده می‌شوند (در بیشتر پوسته‌ها). بیشتر افراد کار کردن با برگه‌ها را از یک برگه‌ی «درباره من» که آن‌ها را به خوانندگان سایت معرفی می‌کند، شروع می‌کنند. برای مثال این‌چنین می‌گویند:\r\n<blockquote>سلام دوستان، من روزها یک کارمند اداری هستم و شب‌ها یک راننده تاکسی، این وبلاگ من است. من در اهواز زندگی می‌کنم که شهری در جنوب غربی ایران است.</blockquote>\r\nیا چیزی شبیه این:\r\n<blockquote>شرکت XYZ در سال ۱۳۶۵ تاسیس شد و ارائه‌دهنده محصولات صنعتی است. این شرکت ۲۰۰۰ کارگر و کارمند دارد. امیدواریم از محصولات ما راضی باشید.</blockquote>\r\nبه‌عنوان یک کاربر تازه‌ی وردپرس فارسی شما برای پاک کردن این برگه و ساختن برگه‌های تازه می‌توانید به <a href=\"http://localhost/demo/wp-admin/\">پیشخوان خود</a> مراجعه کنید. موفق باشید!", "برگه نمونه", "", "publish", "closed", "open", "", "%d8%a8%d8%b1%da%af%d9%87-%d9%86%d9%85%d9%88%d9%86%d9%87", "", "", "2018-12-03 07:15:31", "2018-12-03 03:45:31", "", "0", "http://localhost/demo/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("3", "1", "2018-12-03 06:56:57", "2018-12-03 03:26:57", "<h2>ما که هستیم</h2><p>نشانی وب‌سایت ما هست: http://localhost/demo.</p><h2>کدامیک از اطلاعات شخصی را جمع آوری میکنیم و چرا</h2><h3>دیدگاه‌ها</h3><p>هنگامی که بازدیدکنندگان نظرات خود را در سایت می‌نویسند، ما اطلاعاتی را که در فرم نظرات و همچنین بازدید کننده‌ها ارائه می‌شود جمع آوری می‌کنیم &#8217;s آدرس IP و رجیستر عامل کاربر مرورگر برای کمک به تشخیص هرزنامه.</p><p>یک رشته ناشناس ایجاد شده از آدرس ایمیل شما (همچنین هش نامیده می‌شود) ممکن است به سرویس Gravatar ارائه شود تا ببینید آیا از آن استفاده می‌کنید. سیاست حفظ حریم خصوصی خدمات Gravatar در اینجا در دسترس است: https://automattic.com/privacy/. پس از تأیید نظر شما، تصویر نمایه شما در متن نظر شما قابل مشاهده است.</p><h3>رسانه</h3><p>اگر تصاویر را به وبسایت آپلود کنید، نباید آپلود تصاویر با داده‌های مکان جغرافیایی (EXIF GPS) شامل شود. بازدیدکنندگان وب سایت می‌توانند هر گونه اطلاعات مکان را از تصاویر در وب سایت دانلود و استخراج کنند.</p><h3>فرم‌های تماس</h3><h3>کوکی‌ها</h3><p>اگر شما نظر خود را در سایت ما ثبت کنید، ممکن است برای ذخیره نام، آدرس ایمیل و وب سایت خود در کوکی‌ها تصمیم گیری کنید. اینها برای راحتی شما هستند، به طوری که شما مجبور نیستید دوباره جزئیات خود را پر کنید زمانی که نظر دیگری را ترک کنید. این کوکی‌ها یک سال طول خواهد کشید.</p><p>اگر حساب کاربری دارید و به این سایت وارد می‌شوید، ما کوکی موقت را برای تعیین اینکه آیا مرورگر شما کوکی‌ها را قبول می‌کند تنظیم می‌کند. این کوکی حاوی اطلاعات شخصی نیست و هنگامی که مرورگر شما را میبندد از بین میرود.</p><p>هنگام ورود به سیستم، ما همچنین کوکی‌ها را تنظیم خواهیم کرد تا اطلاعات ورود به سیستم و گزینه‌های صفحه نمایش خود را ذخیره کنید. کوکی‌های ورود به سیستم برای دو روز گذشته و کوکی‌های گزینه‌های صفحه نمایش برای یک سال گذشته است. اگر شما انتخاب کنید &quot; به یاد داشته باشید من Me&quot;، ورود شما برای دو هفته ادامه خواهد داشت. اگر از حساب خود خارج شوید، کوکی‌های ورود حذف خواهند شد.</p><p>اگر یک مقاله را ویرایش یا منتشر کنید، یک کوکی اضافی در مرورگر شما ذخیره خواهد شد. این کوکی حاوی اطلاعات شخصی نیست و به سادگی نشان می‌دهد که شناسه پست مقاله شما فقط ویرایش شده است. بعد از یک روز منقضی می‌شود.</p><h3>محتوای جاسازی‌شده از دیگر وب‌سایت‌ها</h3><p>مقالات موجود در این سایت ممکن است شامل محتوای تعبیه شده (مثلا ویدیوها، تصاویر، مقالات و غیره) باشد. مطالب جاسازی شده از وب سایت‌های دیگر رفتار دقیقا همان طوری که بازدید کننده از وب سایت دیگر بازدید کرده است.</p><p>این وبسایت‌ها ممکن است اطلاعاتی مربوط به شما را جمع‌آوری کنند، از کوکی‌ها استفاده کنند، ردیابی سوم شخص اضافه را جاسازی کنند و تعامل شما را با محتوای تعبیه شده نظارت کنند که شامل ردیابی تعامل شما با محتوای جاسازی شده است اگر حساب کاربری داشته و به آن وبسایت وارد شده باشید.</p><h3>تجزیه و تحلیل</h3><h2>اطلاعت شما را با چه کسی به اشتراک می‌گذاریم</h2><h2>چه مدت ما اطلاعات شما را حفظ می‌کنیم</h2><p>اگر یک نظر را ترک کنید، نظر و متادیتای آن به طور نامحدود حفظ می‌شوند. این به این معنا است که ما می‌توانیم به جای برگزاری آنها در یک خط مؤثر، به طور خودکار هر نظر پیگیری را تصدیق و تأیید کنیم.</p><p>برای کاربرانی که در وب سایت ما ثبت نام می‌کنند (اگر وجود داشته باشند)، ما همچنین اطلاعات شخصی را که در مشخصات کاربر آنها ارائه می‌کنیم، ذخیره می‌کنیم. همه کاربران می‌توانند اطلاعات شخصی خود را در هر زمان (به جز آنها که نمی‌توانند نام کاربری خود را تغییر دهند) ببینند، ویرایش و یا حذف کنند. مدیران وب سایت همچنین می‌توانند این اطلاعات را مشاهده و ویرایش کنند.</p><h2>حقوقی که بر روی داده‌هایتان دارید</h2><p>اگر در این سایت حساب کاربری دارید یا نظرها را ترک کرده اید، می‌توانید درخواست دریافت یک فایل صادر شده از اطلاعات شخصی که ما در مورد شما نگه می‌داریم، از جمله هر گونه داده‌ای که برای ما ارائه کرده اید. همچنین می‌توانید درخواست کنید که ما هر گونه اطلاعات شخصی که در مورد شما نگه داریم پاک کنیم. این شامل اطلاعاتی نیست که ما مجبور به نگهداری آنها برای اهداف اداری، قانونی یا امنیتی باشیم.</p><h2>کجا داده‌های شما را ارسال می‌کنیم</h2><p>دیدگاه‌های بازدیدکننده ممکن است از طریق یک سرویس تشخیص جفنگ بررسی شود.</p><h2>اطلاعات تماس شما</h2><h2>اطلاعات اضافی</h2><h3>چگونه از اطلاعات شما حفاظت می‌کنیم</h3><h3>چه رویه‌های نقض اطلاعات در حال حاضر وجود دارد</h3><h3>چه چیز جدیدی از داده‌ها دریافت می‌کنیم</h3><h3>تصمیم گیری خودکار و / یا پروفایل ما با داده‌های کاربر انجام می‌شود</h3><h3>الزامات افشای قانونی صنعت</h3>", "سیاست حفظ حریم خصوصی", "", "draft", "closed", "open", "", "حفظ-حریم-خصوصی", "", "", "2018-12-03 06:56:57", "2018-12-03 03:26:57", "", "0", "http://localhost/demo/?page_id=3", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("5", "1", "2018-12-03 07:07:29", "2018-12-03 03:37:29", "", "فروشگاه", "", "publish", "closed", "closed", "", "shop", "", "", "2018-12-03 07:07:29", "2018-12-03 03:37:29", "", "0", "http://localhost/demo/shop/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("6", "1", "2018-12-03 07:07:30", "2018-12-03 03:37:30", "[woocommerce_cart]", "سبد خرید", "", "publish", "closed", "closed", "", "cart", "", "", "2018-12-03 07:07:30", "2018-12-03 03:37:30", "", "0", "http://localhost/demo/cart/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("7", "1", "2018-12-03 07:07:30", "2018-12-03 03:37:30", "[woocommerce_checkout]", "پرداخت", "", "publish", "closed", "closed", "", "checkout", "", "", "2018-12-03 07:07:30", "2018-12-03 03:37:30", "", "0", "http://localhost/demo/checkout/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2018-12-03 07:07:30", "2018-12-03 03:37:30", "[woocommerce_my_account]", "حساب کاربری من", "", "publish", "closed", "closed", "", "my-account", "", "", "2018-12-03 07:07:30", "2018-12-03 03:37:30", "", "0", "http://localhost/demo/my-account/", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("9", "1", "2018-12-03 07:15:31", "2018-12-03 03:45:31", "این یک برگه‌ی نمونه است که با یک نوشته در وبلاگ تفاوت دارد زیرا برگه‌ها در یک مکان ثابت می‌مانند و معمولاً در فهرست پیوندهای درونی سایت شما نمایش داده می‌شوند (در بیشتر پوسته‌ها). بیشتر افراد کار کردن با برگه‌ها را از یک برگه‌ی «درباره من» که آن‌ها را به خوانندگان سایت معرفی می‌کند، شروع می‌کنند. برای مثال این‌چنین می‌گویند:\r\n<blockquote>سلام دوستان، من روزها یک کارمند اداری هستم و شب‌ها یک راننده تاکسی، این وبلاگ من است. من در اهواز زندگی می‌کنم که شهری در جنوب غربی ایران است.</blockquote>\r\nیا چیزی شبیه این:\r\n<blockquote>شرکت XYZ در سال ۱۳۶۵ تاسیس شد و ارائه‌دهنده محصولات صنعتی است. این شرکت ۲۰۰۰ کارگر و کارمند دارد. امیدواریم از محصولات ما راضی باشید.</blockquote>\r\nبه‌عنوان یک کاربر تازه‌ی وردپرس فارسی شما برای پاک کردن این برگه و ساختن برگه‌های تازه می‌توانید به <a href=\"http://localhost/demo/wp-admin/\">پیشخوان خود</a> مراجعه کنید. موفق باشید!", "برگه نمونه", "", "inherit", "closed", "closed", "", "2-revision-v1", "", "", "2018-12-03 07:15:31", "2018-12-03 03:45:31", "", "2", "http://localhost/demo/2018/12/03/2-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2018-12-03 07:22:26", "2018-12-03 03:52:26", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-11 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/ds.png\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی اول", "لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد.", "publish", "open", "closed", "", "test1", "", "", "2018-12-03 07:23:49", "2018-12-03 03:53:49", "", "0", "http://localhost/demo/?post_type=product&#038;p=10", "0", "product", "", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2018-12-03 07:21:08", "2018-12-03 03:51:08", "", "ds", "", "inherit", "open", "closed", "", "ds", "", "", "2018-12-03 07:21:08", "2018-12-03 03:51:08", "", "10", "http://localhost/demo/wp-content/uploads/2018/12/ds.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2018-12-03 07:21:16", "2018-12-03 03:51:16", "", "how-to-hire-a-wordpress-developer", "", "inherit", "open", "closed", "", "how-to-hire-a-wordpress-developer", "", "", "2018-12-03 07:21:16", "2018-12-03 03:51:16", "", "10", "http://localhost/demo/wp-content/uploads/2018/12/how-to-hire-a-wordpress-developer.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2018-12-03 07:21:23", "2018-12-03 03:51:23", "", "open-shop-01", "", "inherit", "open", "closed", "", "open-shop-01", "", "", "2018-12-03 07:21:23", "2018-12-03 03:51:23", "", "10", "http://localhost/demo/wp-content/uploads/2018/12/open-shop-01.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2018-12-03 07:21:29", "2018-12-03 03:51:29", "", "shopping_cart", "", "inherit", "open", "closed", "", "shopping_cart", "", "", "2018-12-03 07:21:29", "2018-12-03 03:51:29", "", "10", "http://localhost/demo/wp-content/uploads/2018/12/shopping_cart.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2018-12-03 07:27:27", "2018-12-03 03:57:27", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-12 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/how-to-hire-a-wordpress-developer.png\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی دوم", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد...", "publish", "open", "closed", "", "test2", "", "", "2018-12-03 07:27:34", "2018-12-03 03:57:34", "", "0", "http://localhost/demo/?post_type=product&#038;p=15", "0", "product", "", "1");
INSERT INTO `wp_posts` VALUES("16", "1", "2018-12-03 07:29:54", "2018-12-03 03:59:54", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-13 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/open-shop-01.png\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n&nbsp;\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی سوم", "در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "publish", "open", "closed", "", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d8%aa%d8%b3%d8%aa%db%8c-%d8%b3%d9%88%d9%85", "", "", "2018-12-03 07:30:00", "2018-12-03 04:00:00", "", "0", "http://localhost/demo/?post_type=product&#038;p=16", "0", "product", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2018-12-03 07:39:48", "2018-12-03 04:09:48", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-14 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/shopping_cart.jpg\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی چهارم", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد.", "publish", "open", "closed", "", "test4", "", "", "2018-12-03 07:39:55", "2018-12-03 04:09:55", "", "0", "http://localhost/demo/?post_type=product&#038;p=17", "0", "product", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2018-12-03 07:44:38", "2018-12-03 04:14:38", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-14 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/shopping_cart.jpg\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی پنجم", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد.", "publish", "open", "closed", "", "test5", "", "", "2018-12-03 07:45:28", "2018-12-03 04:15:28", "", "0", "http://localhost/demo/?post_type=product&#038;p=18", "0", "product", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2018-12-03 07:45:59", "2018-12-03 04:15:59", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-13 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/open-shop-01.png\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n&nbsp;\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی ششم", "در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "publish", "open", "closed", "", "test6", "", "", "2018-12-03 07:46:46", "2018-12-03 04:16:46", "", "0", "http://localhost/demo/?post_type=product&#038;p=19", "0", "product", "", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2018-12-03 07:47:26", "2018-12-03 04:17:26", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-12 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/how-to-hire-a-wordpress-developer.png\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی هفتم", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد...", "publish", "open", "closed", "", "test7", "", "", "2018-12-03 07:48:13", "2018-12-03 04:18:13", "", "0", "http://localhost/demo/?post_type=product&#038;p=20", "0", "product", "", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2018-12-03 07:48:47", "2018-12-03 04:18:47", "کتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.\r\n\r\n<img class=\"aligncenter wp-image-11 size-full\" src=\"http://localhost/demo/wp-content/uploads/2018/12/ds.png\" alt=\"\" width=\"800\" height=\"600\" />\r\n\r\nکتابهای زیادی در شصت و سه درصد گذشته، حال و آینده شناخت فراوان جامعه و متخصصان را می طلبد تا با نرم افزارها شناخت بیشتری را برای طراحان رایانه ای علی الخصوص طراحان خلاقی و فرهنگ پیشرو در زبان فارسی ایجاد کرد. در این صورت می توان امید داشت که تمام و دشواری موجود در ارائه راهکارها و شرایط سخت تایپ به پایان رسد وزمان مورد نیاز شامل حروفچینی دستاوردهای اصلی و جوابگوی سوالات پیوسته اهل دنیای موجود طراحی اساسا مورد استفاده قرار گیرد.", "محصول تستی هشتم", "لورم ایپسوم متن ساختگی با تولید سادگی نامفهوم از صنعت چاپ و با استفاده از طراحان گرافیک است. چاپگرها و متون بلکه روزنامه و مجله در ستون و سطرآنچنان که لازم است و برای شرایط فعلی تکنولوژی مورد نیاز و کاربردهای متنوع با هدف بهبود ابزارهای کاربردی می باشد.", "publish", "open", "closed", "", "test8", "", "", "2018-12-03 07:49:43", "2018-12-03 04:19:43", "", "0", "http://localhost/demo/?post_type=product&#038;p=21", "0", "product", "", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2018-12-03 07:51:05", "2018-12-03 04:21:05", "http://localhost/demo/wp-content/uploads/2018/12/cropped-how-to-hire-a-wordpress-developer.png", "cropped-how-to-hire-a-wordpress-developer.png", "", "inherit", "open", "closed", "", "cropped-how-to-hire-a-wordpress-developer-png", "", "", "2018-12-03 07:51:05", "2018-12-03 04:21:05", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/cropped-how-to-hire-a-wordpress-developer.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2018-12-03 07:58:03", "2018-12-03 04:28:03", "{\n    \"blogdescription\": {\n        \"value\": \"\\u0641\\u0631\\u0648\\u0634\\u06af\\u0627\\u0647 \\u06a9\\u0648\\u0686\\u06a9 \\u0645\\u0646\",\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:21:49\"\n    },\n    \"jstore::custom_logo\": {\n        \"value\": \"\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:21:49\"\n    },\n    \"jstore::jstore_cust_care_text\": {\n        \"value\": \"\\u0641\\u0631\\u0648\\u0634\\u06af\\u0627\\u0647 \\u0627\\u06cc\\u0646\\u062a\\u0631\\u0646\\u062a\\u06cc \\u062c\\u06cc \\u0627\\u0633\\u062a\\u0648\\u0631 \\u0641\\u0627\\u0631\\u0633\\u06cc\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:21:49\"\n    },\n    \"jstore::jstore_home_banner_on_off\": {\n        \"value\": \"on\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:22:00\"\n    },\n    \"jstore::jstore_bnr_img1\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/sbanner1-1-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:22:58\"\n    },\n    \"jstore::jstore_bnr_img2\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/sbanner3-1-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:24:00\"\n    },\n    \"jstore::jstore_small_banner_on_off\": {\n        \"value\": \"on\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:24:00\"\n    },\n    \"jstore::jstore-small-banner-1\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/sbanner3-1-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:24:00\"\n    },\n    \"jstore::jstore-small-banner-2\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/sbanner1-1-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:24:00\"\n    },\n    \"jstore::jstore-small-banner-3\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/sbanner2-1-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:24:59\"\n    },\n    \"jstore::jstore_our_brand_logo1\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/01-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:24:59\"\n    },\n    \"jstore::jstore_our_brand_logo2\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/02-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:26:04\"\n    },\n    \"jstore::jstore_our_brand_logo3\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/04-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:26:04\"\n    },\n    \"jstore::jstore_our_brand_logo4\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/06-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:26:04\"\n    },\n    \"jstore::jstore_our_brand_logo5\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/03-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:26:04\"\n    },\n    \"jstore::jstore_our_brand_logo6\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/07-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:26:04\"\n    },\n    \"jstore::jstore_copyright_text\": {\n        \"value\": \"\\u0637\\u0631\\u0627\\u062d\\u06cc \\u0648 \\u0627\\u062c\\u0631\\u0627 : \\u0627\\u06cc\\u0631\\u0627\\u0646 \\u062a\\u0645\\u0632\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:28:03\"\n    },\n    \"jstore::header_image\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/cropped-shopping_cart.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:26:58\"\n    },\n    \"jstore::header_image_data\": {\n        \"value\": {\n            \"url\": \"http://localhost/demo/wp-content/uploads/2018/12/cropped-shopping_cart.jpg\",\n            \"thumbnail_url\": \"http://localhost/demo/wp-content/uploads/2018/12/cropped-shopping_cart.jpg\",\n            \"timestamp\": 1543811198453,\n            \"attachment_id\": 33,\n            \"width\": 2000,\n            \"height\": 807\n        },\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:26:58\"\n    },\n    \"sidebars_widgets[jstore-footer1]\": {\n        \"value\": [\n            \"woocommerce_product_tag_cloud-3\",\n            \"pages-3\",\n            \"recent-posts-4\"\n        ],\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:28:03\"\n    },\n    \"jstore::jstore_cust_care_no\": {\n        \"value\": \"09158856205\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:28:03\"\n    },\n    \"widget_woocommerce_product_tag_cloud[3]\": {\n        \"value\": [],\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:28:03\"\n    },\n    \"widget_pages[3]\": {\n        \"value\": {\n            \"encoded_serialized_instance\": \"YTozOntzOjU6InRpdGxlIjtzOjIxOiLYr9iz2KrYsdiz24wg2LPYsduM2LkiO3M6Njoic29ydGJ5IjtzOjEwOiJwb3N0X3RpdGxlIjtzOjc6ImV4Y2x1ZGUiO3M6MDoiIjt9\",\n            \"title\": \"\\u062f\\u0633\\u062a\\u0631\\u0633\\u06cc \\u0633\\u0631\\u06cc\\u0639\",\n            \"is_widget_customizer_js_value\": true,\n            \"instance_hash_key\": \"765b76f523331a58a3e3402ae57e882a\"\n        },\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:28:03\"\n    },\n    \"widget_recent-posts[4]\": {\n        \"value\": {\n            \"encoded_serialized_instance\": \"YTozOntzOjU6InRpdGxlIjtzOjI3OiLYrNiv24zYr9iq2LHbjNmGINmF2LfYp9mE2KgiO3M6NjoibnVtYmVyIjtpOjM7czo5OiJzaG93X2RhdGUiO2I6MDt9\",\n            \"title\": \"\\u062c\\u062f\\u06cc\\u062f\\u062a\\u0631\\u06cc\\u0646 \\u0645\\u0637\\u0627\\u0644\\u0628\",\n            \"is_widget_customizer_js_value\": true,\n            \"instance_hash_key\": \"df02429e8da18860cdd4f33a502e3ad2\"\n        },\n        \"type\": \"option\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:28:03\"\n    }\n}", "", "", "trash", "closed", "closed", "", "d016d6ad-008d-46be-a22f-5af22ed83b25", "", "", "2018-12-03 07:58:03", "2018-12-03 04:28:03", "", "0", "http://localhost/demo/?p=23", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2018-12-03 07:52:42", "2018-12-03 04:22:42", "", "sbanner1-1-2", "", "inherit", "open", "closed", "", "sbanner1-1-2", "", "", "2018-12-03 07:52:42", "2018-12-03 04:22:42", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/sbanner1-1-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2018-12-03 07:53:16", "2018-12-03 04:23:16", "", "sbanner3-1-2", "", "inherit", "open", "closed", "", "sbanner3-1-2", "", "", "2018-12-03 07:53:16", "2018-12-03 04:23:16", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/sbanner3-1-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2018-12-03 07:54:10", "2018-12-03 04:24:10", "", "sbanner2-1-2", "", "inherit", "open", "closed", "", "sbanner2-1-2", "", "", "2018-12-03 07:54:10", "2018-12-03 04:24:10", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/sbanner2-1-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2018-12-03 07:54:42", "2018-12-03 04:24:42", "", "01-2", "", "inherit", "open", "closed", "", "01-2", "", "", "2018-12-03 07:54:42", "2018-12-03 04:24:42", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/01-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2018-12-03 07:54:58", "2018-12-03 04:24:58", "", "02-2", "", "inherit", "open", "closed", "", "02-2", "", "", "2018-12-03 07:54:58", "2018-12-03 04:24:58", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/02-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2018-12-03 07:55:03", "2018-12-03 04:25:03", "", "03-2", "", "inherit", "open", "closed", "", "03-2", "", "", "2018-12-03 07:55:03", "2018-12-03 04:25:03", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/03-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2018-12-03 07:55:08", "2018-12-03 04:25:08", "", "04-2", "", "inherit", "open", "closed", "", "04-2", "", "", "2018-12-03 07:55:08", "2018-12-03 04:25:08", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/04-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2018-12-03 07:55:15", "2018-12-03 04:25:15", "", "06-2", "", "inherit", "open", "closed", "", "06-2", "", "", "2018-12-03 07:55:15", "2018-12-03 04:25:15", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/06-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2018-12-03 07:55:24", "2018-12-03 04:25:24", "", "07-2", "", "inherit", "open", "closed", "", "07-2", "", "", "2018-12-03 07:55:24", "2018-12-03 04:25:24", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/07-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2018-12-03 07:56:35", "2018-12-03 04:26:35", "", "cropped-shopping_cart.jpg", "", "inherit", "open", "closed", "", "cropped-shopping_cart-jpg", "", "", "2018-12-03 07:56:35", "2018-12-03 04:26:35", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/cropped-shopping_cart.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2018-12-03 08:05:00", "2018-12-03 04:35:00", "{\n    \"jstore::header_image\": {\n        \"value\": \"remove-header\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:34:12\"\n    },\n    \"jstore::header_image_data\": {\n        \"value\": \"remove-header\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:34:12\"\n    }\n}", "", "", "trash", "closed", "closed", "", "15bc9b6c-45f9-4b2d-ba4a-92c4c1e4ff88", "", "", "2018-12-03 08:05:00", "2018-12-03 04:35:00", "", "0", "http://localhost/demo/?p=34", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("35", "1", "2018-12-03 08:06:31", "2018-12-03 04:36:31", "", "صفحه اصلی فروشگاه", "", "publish", "closed", "closed", "", "index", "", "", "2018-12-03 08:06:31", "2018-12-03 04:36:31", "", "0", "http://localhost/demo/?page_id=35", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2018-12-03 08:06:31", "2018-12-03 04:36:31", "", "صفحه اصلی فروشگاه", "", "inherit", "closed", "closed", "", "35-revision-v1", "", "", "2018-12-03 08:06:31", "2018-12-03 04:36:31", "", "35", "http://localhost/demo/2018/12/03/35-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2018-12-03 08:11:29", "2018-12-03 04:41:29", "", "banner02-1-2", "", "inherit", "open", "closed", "", "banner02-1-2", "", "", "2018-12-03 08:11:29", "2018-12-03 04:41:29", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/banner02-1-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2018-12-03 08:11:37", "2018-12-03 04:41:37", "", "sbanner1-1-2", "", "inherit", "open", "closed", "", "sbanner1-1-2-2", "", "", "2018-12-03 08:11:37", "2018-12-03 04:41:37", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/sbanner1-1-2-1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("39", "1", "2018-12-03 08:11:43", "2018-12-03 04:41:43", "", "sbanner2-1-2", "", "inherit", "open", "closed", "", "sbanner2-1-2-2", "", "", "2018-12-03 08:11:43", "2018-12-03 04:41:43", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/sbanner2-1-2-1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2018-12-03 08:11:48", "2018-12-03 04:41:48", "", "sbanner3-1-2", "", "inherit", "open", "closed", "", "sbanner3-1-2-2", "", "", "2018-12-03 08:11:48", "2018-12-03 04:41:48", "", "0", "http://localhost/demo/wp-content/uploads/2018/12/sbanner3-1-2-1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("41", "1", "2018-12-03 08:14:27", "2018-12-03 04:44:27", "{\n    \"jstore::jstore_bnr_img1\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/banner02-1-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:42:41\"\n    },\n    \"jstore::jstore_bnr_img2\": {\n        \"value\": \"http://localhost/demo/wp-content/uploads/2018/12/banner02-1-2.jpg\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:42:41\"\n    },\n    \"jstore::jstore_new_arvl_itm\": {\n        \"value\": \"\\u062c\\u062f\\u06cc\\u062f\\u062a\\u0631\\u06cc\\u0646 \\u0645\\u062d\\u0635\\u0648\\u0644\\u0627\\u062a\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:44:27\"\n    },\n    \"jstore::jstore_top_rtd_itm\": {\n        \"value\": \"\\u0645\\u062d\\u0635\\u0648\\u0644\\u0627\\u062a \\u062f\\u0627\\u0631\\u0627\\u06cc \\u0628\\u06cc\\u0634\\u062a\\u0631\\u06cc\\u0646 \\u0627\\u0645\\u062a\\u06cc\\u0627\\u0632\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:44:27\"\n    },\n    \"jstore::jstore_top_seling_itm\": {\n        \"value\": \"\\u067e\\u0631\\u0641\\u0631\\u0648\\u0634 \\u062a\\u0631\\u06cc\\u0646 \\u0645\\u062d\\u0635\\u0648\\u0644\\u0627\\u062a\",\n        \"type\": \"theme_mod\",\n        \"user_id\": 1,\n        \"date_modified_gmt\": \"2018-12-03 04:44:27\"\n    }\n}", "", "", "trash", "closed", "closed", "", "4878f970-a07b-4f6d-8f15-bf2a157a5a03", "", "", "2018-12-03 08:14:27", "2018-12-03 04:44:27", "", "0", "http://localhost/demo/?p=41", "0", "customize_changeset", "", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2018-12-10 09:46:57", "0000-00-00 00:00:00", "", "پیش‌نویس خودکار", "", "auto-draft", "open", "open", "", "", "", "", "2018-12-10 09:46:57", "0000-00-00 00:00:00", "", "0", "http://localhost/demo/?p=42", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2018-12-10 09:50:02", "0000-00-00 00:00:00", "", "پیش‌نویس خودکار", "", "auto-draft", "open", "open", "", "", "", "", "2018-12-10 09:50:02", "0000-00-00 00:00:00", "", "0", "http://localhost/demo/?p=43", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2018-12-10 09:51:41", "0000-00-00 00:00:00", "", "پیش‌نویس خودکار", "", "auto-draft", "open", "open", "", "", "", "", "2018-12-10 09:51:41", "0000-00-00 00:00:00", "", "0", "http://localhost/demo/?p=44", "0", "post", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("10", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("10", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("10", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("10", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("10", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "19", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "product_type", "", "0", "8");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "product_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "product_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "product_type", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("9", "9", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("10", "10", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("11", "11", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("12", "12", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("13", "13", "product_visibility", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("14", "14", "product_visibility", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("15", "15", "product_cat", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("16", "16", "product_cat", "", "0", "8");
INSERT INTO `wp_term_taxonomy` VALUES("17", "17", "product_cat", "", "0", "8");
INSERT INTO `wp_term_taxonomy` VALUES("18", "18", "product_tag", "", "0", "8");
INSERT INTO `wp_term_taxonomy` VALUES("19", "19", "product_tag", "", "0", "8");
INSERT INTO `wp_term_taxonomy` VALUES("20", "20", "product_cat", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("21", "21", "product_tag", "", "0", "2");

/* INSERT TABLE DATA: wp_termmeta */
INSERT INTO `wp_termmeta` VALUES("1", "16", "order", "0");
INSERT INTO `wp_termmeta` VALUES("2", "17", "order", "0");
INSERT INTO `wp_termmeta` VALUES("3", "17", "product_count_product_cat", "8");
INSERT INTO `wp_termmeta` VALUES("4", "16", "product_count_product_cat", "8");
INSERT INTO `wp_termmeta` VALUES("5", "18", "product_count_product_tag", "8");
INSERT INTO `wp_termmeta` VALUES("6", "19", "product_count_product_tag", "8");
INSERT INTO `wp_termmeta` VALUES("7", "20", "order", "0");
INSERT INTO `wp_termmeta` VALUES("8", "20", "product_count_product_cat", "6");
INSERT INTO `wp_termmeta` VALUES("9", "21", "product_count_product_tag", "2");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "دسته‌بندی نشده", "%d8%af%d8%b3%d8%aa%d9%87%e2%80%8c%d8%a8%d9%86%d8%af%db%8c-%d9%86%d8%b4%d8%af%d9%87", "0");
INSERT INTO `wp_terms` VALUES("2", "simple", "simple", "0");
INSERT INTO `wp_terms` VALUES("3", "grouped", "grouped", "0");
INSERT INTO `wp_terms` VALUES("4", "variable", "variable", "0");
INSERT INTO `wp_terms` VALUES("5", "external", "external", "0");
INSERT INTO `wp_terms` VALUES("6", "exclude-from-search", "exclude-from-search", "0");
INSERT INTO `wp_terms` VALUES("7", "exclude-from-catalog", "exclude-from-catalog", "0");
INSERT INTO `wp_terms` VALUES("8", "featured", "featured", "0");
INSERT INTO `wp_terms` VALUES("9", "outofstock", "outofstock", "0");
INSERT INTO `wp_terms` VALUES("10", "rated-1", "rated-1", "0");
INSERT INTO `wp_terms` VALUES("11", "rated-2", "rated-2", "0");
INSERT INTO `wp_terms` VALUES("12", "rated-3", "rated-3", "0");
INSERT INTO `wp_terms` VALUES("13", "rated-4", "rated-4", "0");
INSERT INTO `wp_terms` VALUES("14", "rated-5", "rated-5", "0");
INSERT INTO `wp_terms` VALUES("15", "بدون دسته‌بندی", "%d8%a8%d8%af%d9%88%d9%86-%d8%af%d8%b3%d8%aa%d9%87%e2%80%8c%d8%a8%d9%86%d8%af%db%8c", "0");
INSERT INTO `wp_terms` VALUES("16", "محصول تستی", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d8%aa%d8%b3%d8%aa%db%8c", "0");
INSERT INTO `wp_terms` VALUES("17", "محصول آزمایشی", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d8%a2%d8%b2%d9%85%d8%a7%db%8c%d8%b4%db%8c", "0");
INSERT INTO `wp_terms` VALUES("18", "محصول تستی", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d8%aa%d8%b3%d8%aa%db%8c", "0");
INSERT INTO `wp_terms` VALUES("19", "محصول آزمایشی", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d8%a2%d8%b2%d9%85%d8%a7%db%8c%d8%b4%db%8c", "0");
INSERT INTO `wp_terms` VALUES("20", "محصول نمایشی", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d9%86%d9%85%d8%a7%db%8c%d8%b4%db%8c", "0");
INSERT INTO `wp_terms` VALUES("21", "محصول نمایشی", "%d9%85%d8%ad%d8%b5%d9%88%d9%84-%d9%86%d9%85%d8%a7%db%8c%d8%b4%db%8c", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "syntax_highlighting", "true");
INSERT INTO `wp_usermeta` VALUES("7", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("8", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("9", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("10", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("11", "1", "locale", "");
INSERT INTO `wp_usermeta` VALUES("12", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("13", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("14", "1", "dismissed_wp_pointers", "wp496_privacy");
INSERT INTO `wp_usermeta` VALUES("15", "1", "show_welcome_panel", "0");
INSERT INTO `wp_usermeta` VALUES("16", "1", "session_tokens", "a:1:{s:64:\"9ddba852c4b9ae9cd51e6bf9130f7e573cd350ea017c8c57642356c1bb55ab30\";a:4:{s:10:\"expiration\";i:1545017239;s:2:\"ip\";s:9:\"127.0.0.1\";s:2:\"ua\";s:65:\"Mozilla/5.0 (Windows NT 6.1; rv:63.0) Gecko/20100101 Firefox/63.0\";s:5:\"login\";i:1543807639;}}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_dashboard_quick_press_last_post_id", "42");
INSERT INTO `wp_usermeta` VALUES("18", "1", "community-events-location", "a:1:{s:2:\"ip\";s:9:\"127.0.0.0\";}");
INSERT INTO `wp_usermeta` VALUES("19", "1", "show_try_gutenberg_panel", "0");
INSERT INTO `wp_usermeta` VALUES("20", "1", "_woocommerce_persistent_cart_1", "a:1:{s:4:\"cart\";a:1:{s:32:\"d3d9446802a44259755d38e6d163e820\";a:11:{s:3:\"key\";s:32:\"d3d9446802a44259755d38e6d163e820\";s:10:\"product_id\";i:10;s:12:\"variation_id\";i:0;s:9:\"variation\";a:0:{}s:8:\"quantity\";i:1;s:9:\"data_hash\";s:32:\"b5c1d5ca8bae6d4896cf1807cdf763f0\";s:13:\"line_tax_data\";a:2:{s:8:\"subtotal\";a:0:{}s:5:\"total\";a:0:{}}s:13:\"line_subtotal\";d:40000;s:17:\"line_subtotal_tax\";i:0;s:10:\"line_total\";d:40000;s:8:\"line_tax\";i:0;}}}");
INSERT INTO `wp_usermeta` VALUES("21", "1", "dismissed_no_secure_connection_notice", "1");
INSERT INTO `wp_usermeta` VALUES("22", "1", "wc_last_active", "1544400000");
INSERT INTO `wp_usermeta` VALUES("23", "1", "wp_user-settings", "libraryContent=browse");
INSERT INTO `wp_usermeta` VALUES("24", "1", "wp_user-settings-time", "1543809153");
INSERT INTO `wp_usermeta` VALUES("25", "1", "dismissed_no_shipping_methods_notice", "1");
INSERT INTO `wp_usermeta` VALUES("26", "1", "dismissed_store_notice_setting_moved_notice", "1");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admin", "$P$BRzJ8kCfC/0YlG3a8xbHkl3yDCDsSH0", "admin", "demo@iranthemes.com", "", "2018-12-03 03:26:56", "", "0", "admin");

/* INSERT TABLE DATA: wp_woocommerce_sessions */
INSERT INTO `wp_woocommerce_sessions` VALUES("2", "1", "a:7:{s:4:\"cart\";s:416:\"a:1:{s:32:\"d3d9446802a44259755d38e6d163e820\";a:11:{s:3:\"key\";s:32:\"d3d9446802a44259755d38e6d163e820\";s:10:\"product_id\";i:10;s:12:\"variation_id\";i:0;s:9:\"variation\";a:0:{}s:8:\"quantity\";i:1;s:9:\"data_hash\";s:32:\"b5c1d5ca8bae6d4896cf1807cdf763f0\";s:13:\"line_tax_data\";a:2:{s:8:\"subtotal\";a:0:{}s:5:\"total\";a:0:{}}s:13:\"line_subtotal\";d:40000;s:17:\"line_subtotal_tax\";i:0;s:10:\"line_total\";d:40000;s:8:\"line_tax\";i:0;}}\";s:11:\"cart_totals\";s:399:\"a:15:{s:8:\"subtotal\";s:5:\"40000\";s:12:\"subtotal_tax\";d:0;s:14:\"shipping_total\";s:1:\"0\";s:12:\"shipping_tax\";d:0;s:14:\"shipping_taxes\";a:0:{}s:14:\"discount_total\";d:0;s:12:\"discount_tax\";d:0;s:19:\"cart_contents_total\";s:5:\"40000\";s:17:\"cart_contents_tax\";d:0;s:19:\"cart_contents_taxes\";a:0:{}s:9:\"fee_total\";s:1:\"0\";s:7:\"fee_tax\";d:0;s:9:\"fee_taxes\";a:0:{}s:5:\"total\";s:5:\"40000\";s:9:\"total_tax\";d:0;}\";s:15:\"applied_coupons\";s:6:\"a:0:{}\";s:22:\"coupon_discount_totals\";s:6:\"a:0:{}\";s:26:\"coupon_discount_tax_totals\";s:6:\"a:0:{}\";s:21:\"removed_cart_contents\";s:6:\"a:0:{}\";s:8:\"customer\";s:707:\"a:26:{s:2:\"id\";s:1:\"1\";s:13:\"date_modified\";s:0:\"\";s:8:\"postcode\";s:0:\"\";s:4:\"city\";s:0:\"\";s:9:\"address_1\";s:0:\"\";s:7:\"address\";s:0:\"\";s:9:\"address_2\";s:0:\"\";s:5:\"state\";s:0:\"\";s:7:\"country\";s:2:\"IR\";s:17:\"shipping_postcode\";s:0:\"\";s:13:\"shipping_city\";s:0:\"\";s:18:\"shipping_address_1\";s:0:\"\";s:16:\"shipping_address\";s:0:\"\";s:18:\"shipping_address_2\";s:0:\"\";s:14:\"shipping_state\";s:0:\"\";s:16:\"shipping_country\";s:2:\"IR\";s:13:\"is_vat_exempt\";s:0:\"\";s:19:\"calculated_shipping\";s:0:\"\";s:10:\"first_name\";s:0:\"\";s:9:\"last_name\";s:0:\"\";s:7:\"company\";s:0:\"\";s:5:\"phone\";s:0:\"\";s:5:\"email\";s:19:\"demo@iranthemes.com\";s:19:\"shipping_first_name\";s:0:\"\";s:18:\"shipping_last_name\";s:0:\"\";s:16:\"shipping_company\";s:0:\"\";}\";}", "1544594964");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2018-12-10 06:27:32*/
/* DUPLICATOR_MYSQLDUMP_EOF */
